using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.Common.Core.Utils;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;

namespace ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacLotPlayMode
{
    /// <summary>
    /// Ϲ
    /// </summary>
    public class MacLotPlayModeJlHhggService : MacLotPlayModeService
    {
        public MacLotPlayModeJlHhggService()
        {
            PlayFullName = "Ϲ";
        }
        #region Overrides of MacLotPlayModeService

        /// <summary>
        /// ͶעģʽϢ
        /// </summary>
        /// <summary>
        /// ͶעҪ͵ļб
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="machineEntity"></param>
        /// <returns></returns>
        public override List<KeycodeInfo> GetSendKeycodeList(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity)
        {
            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ʼÿζҪ淨Ͷע
            keycodeList.AddRange(GetInitKeycodeList(machineModeConfig));

            //Ͷע
            List<JcCodeEntity> codeList = DealPrintCode(ticketEntity.L_Code);
            foreach (JcCodeEntity jcCodeEntity in codeList)
            {
                //볡ѡ
                //keycodeList.Add(new KeycodeInfo(WeekInitKey, machineModeConfig.C_SendKeyInterval));
                //ѡ񳡴
                for (int i = 0; i < jcCodeEntity.ChangCi.Length; i++)
                {
                    keycodeList.Add(new KeycodeInfo(jcCodeEntity.ChangCi.Substring(i, 1), machineModeConfig.C_SendKeyInterval));
                }
                //ѡ񳡴ε淨
                switch (jcCodeEntity.PlayId)
                {
                    case 95101:
                        //keycodeList.Add(new KeycodeInfo("6", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("1", machineModeConfig.C_SendKeyInterval));
                        break;
                    case 95102:
                        //keycodeList.Add(new KeycodeInfo("6", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("2", machineModeConfig.C_SendKeyInterval));
                        break;
                    case 95103:
                        //keycodeList.Add(new KeycodeInfo("6", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("3", machineModeConfig.C_SendKeyInterval));
                        break;
                    case 95104:
                        //keycodeList.Add(new KeycodeInfo("6", machineModeConfig.C_SendKeyInterval));
                        keycodeList.Add(new KeycodeInfo("4", machineModeConfig.C_SendKeyInterval));
                        break;
                }

                //ѡͶע
                foreach (string s in jcCodeEntity.OneCodeList)
                {
                    keycodeList.Add(new KeycodeInfo(s, machineModeConfig.C_SendKeyInterval));
                }
                //Ͷעȷ
                keycodeList.Add(new KeycodeInfo(ResultEnterKey, machineModeConfig.C_SendKeyInterval));
            }

            //Ͷ
            if (ticketEntity.L_Mutiple > 1)
            {
                keycodeList.AddRange(GetMultipleKeycodeList(ticketEntity.L_Mutiple, machineModeConfig));
            }

            //طʽ
            keycodeList.AddRange(GetGuoGuanKeycodeList(ticketEntity.L_CodeType, machineModeConfig));

            //ӡȷ
            keycodeList.Add(new KeycodeInfo(machineModeConfig.C_PrintConfirmKey, machineModeConfig.C_PrintConfirmKeyInterval));

            //Ƿ
            keycodeList.AddRange(GetPasswordKeycodeList(ticketEntity, machineEntity, machineModeConfig));

            return keycodeList;
        }
        /// <summary>
        /// Ͷע
        /// </summary>
        /// <param name="code"></param>
        /// <returns></returns>
        protected List<JcCodeEntity> DealPrintCode(string code)
        {
            List<JcCodeEntity> codeList = new List<JcCodeEntity>();
            string[] changCiCodeArr = code.Split(CodeSplitStr.ToCharArray()); //ʾжٳ
            foreach (string changCiCode in changCiCodeArr)
            {
                JcCodeEntity jcCodeEntity = new JcCodeEntity();

                string[] arr = changCiCode.Split(MatchCodeSplitStr.ToCharArray());

                jcCodeEntity.ChangCi = arr[0];
                string[] arrPlayAndCode = arr[1].Split('[');
                jcCodeEntity.PlayId = int.Parse(arrPlayAndCode[0]);
                string s = arrPlayAndCode[1].Replace("]", "");
                string[] oneMatchCodeArr;
                switch (jcCodeEntity.PlayId)
                {
                    case 95101:
                        oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                        jcCodeEntity.OneCodeList.AddRange(oneMatchCodeArr);
                        break;
                    case 95102:
                        oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                        jcCodeEntity.OneCodeList.AddRange(oneMatchCodeArr);
                        break;
                    case 95103:
                        oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                        for (int i = 0; i < oneMatchCodeArr.Length; i++)
                        {
                            for (int j = 0; j < oneMatchCodeArr[i].Length; j++)
                            {
                                jcCodeEntity.OneCodeList.Add(oneMatchCodeArr[i].Substring(j, 1));
                            }
                        }
                        break;
                    case 95104:
                        oneMatchCodeArr = s.Split(SplitStr.ToCharArray());
                        jcCodeEntity.OneCodeList.AddRange(oneMatchCodeArr);
                        break;
                }
                
                codeList.Add(jcCodeEntity);
            }
            return codeList;

        }

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="machineEntity"></param>
        /// <param name="decodePrintData"></param>
        /// <param name="ticketEntity"></param>
        public override void DecodeData(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity, DecodePrintData decodePrintData)
        {
            //M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ץȡķ
            decodePrintData.L_PrintTicketEntity.P_PrnText = TicketTextUtil.CompressAndEncrypt(decodePrintData.InputData.CaptureDataBytes);
            //decodePrintData.L_PrintTicketEntity.P_SucTime = DateTime.Now;

            string input = decodePrintData.InputData.CaptureDataString;
            //input = input.Replace("͸12035ڿ01+04+30+32+35 08+12", "");
            string strTemp;
            //Ʊš롢ںŽ
            bool suc = DecodeHeadJc(ticketEntity, machineEntity, decodePrintData);
            if (!suc)
            {
                decodePrintData.ErrorMessage = string.Format("ͷ{0}", decodePrintData.ErrorMessage);
                decodePrintData.DecodeSuccess = false;
                return;
            }

            Regex regex;
            Match match;

            #region Ͷע뼰
            List<string> dCodeList = new List<string>();
            List<string> dRateList = new List<string>();
            List<string> codeReferenceList = new List<string>(); //οʣˮλ  1301[÷, ÷]  1301[+8.5,+9.5]]/1302[+2.5,+3.5];
            //
            int startposition = input.IndexOf(decodePrintData.L_PrintTicketEntity.P_TicketCode) + 60;
            int endposition = input.IndexOf("Ʊ߿̶ܹ", startposition);
            strTemp = input.Substring(startposition, endposition - startposition);//Ͷעݵַ

            //2020.1.7 ַб ݵб滻֮ǰ
            strTemp = strTemp.Replace("", "̶÷:-");
            strTemp = strTemp.Replace("", "̶÷:+");
            strTemp = strTemp.Replace("̶Ԥܷ:", "Ԥܷ:");

            string[] tmpArr = strTemp.Split('\n');//Ͷעʱ

            regex = new Regex(@"(һ||||||)\d{3}\s{1,}(÷ʤ\s{1,}̶÷:[\+-]\d{1,}\.\d{1,}|ʤ|ʤֲ|С\s{1,}Ԥܷ:\d{1,}\.\d{1,})");
            //regex = new Regex(@"(һ||||||)\d{3}\s{1,}(÷ʤ\s{1,}̶÷:[\+-]\d{1,}\.\d{1,}|ʤ|ʤֲ|С\s{1,}̶Ԥܷ:\d{1,}\.\d{1,})");
            for (int i = 0; i < tmpArr.Length; i++)
            {
                strTemp = tmpArr[i].Trim();
                match = regex.Match(strTemp);
                if (match.Success)
                {
                    strTemp = match.Value;
                    strTemp=Regex.Replace(strTemp, @"\s{1,}", " ");
                    string[] arrChangCi = strTemp.Split(' ');
                    if(arrChangCi.Length<2)
                    {
                        decodePrintData.ErrorMessage += string.Concat("ʳʧܣ", match.Value);
                        decodePrintData.DecodeSuccess = false;
                        return;
                    }
                    string strChangCi = DealChangChi(arrChangCi[0]);//ַ 磺1  002
                    int playIdOfRate = 0;
                    string rangScore = "";
                    switch (arrChangCi[1])
                    {
                        case "÷ʤ":
                            playIdOfRate = 95101;
                            rangScore = string.Concat(" ,", arrChangCi[2].Replace("̶÷:", ""));
                            break;
                        case "ʤ":
                            playIdOfRate = 95102;
                            break;
                        case "ʤֲ":
                            playIdOfRate = 95103;
                            break;
                        case "С":
                            playIdOfRate = 95104;
                            rangScore = string.Concat(" ,", arrChangCi[2].Replace("Ԥܷ:", ""));
                            break;
                    }

                    //i++;//εһΪ÷ 磺÷:-8.5 ̶÷:-8.5
                    //strTemp = new Regex(@"÷:[\+-]\d{1,}\.\d{1,}\s{1,}̶÷:[\+-]\d{1,}\.\d{1,}").Match(tmpArr[i]).Value;
                    //strTemp = Regex.Replace(strTemp, @"\s{1,}", ",");
                    //string[] TmpArr_LF = strTemp.Split(',');
                    //if (TmpArr_LF.Length != 2)
                    //{
                    //    decodePrintData.ErrorMessage += string.Concat("÷д󣬻ȡַ", strTemp);
                    //    decodePrintData.DecodeSuccess = false;
                    //    return;
                    //}

                    //codeReferenceList.Add(string.Format("{0}{1}{2}[{3},{4}]", strChangCi, MatchCodeSplitStr, playIdOfRate, TmpArr_LF[0].Trim().Replace("÷:", ""), TmpArr_LF[1].Trim().Replace("̶÷:", "")));
                    if (playIdOfRate==95101||playIdOfRate==95104)
                    {
                        codeReferenceList.Add(string.Format("{0}{1}{2}[{3}]", strChangCi, MatchCodeSplitStr, playIdOfRate, rangScore));
                    }


                    i++;//εһΪ 磺:Ī˹ƻͷ Vs Ͷ:϶Ͷ    
                    i++;//ƵһΪͶע 磺ʤ@2.540Ԫ
                    string tmpCodeStr = "";
                    //while (!new Regex(@"M\0!\0a\0").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))
                    //while (!new Regex(@"\d{1,}").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))   //2017-05-27 ظĳɳ
                    while (!new Regex(@"\d{1,}(|)").IsMatch(tmpArr[i]) && !new Regex(@"ѡ̶").IsMatch(tmpArr[i]))
                    {
                        //Ͷעݿж
                        if (tmpArr[i].IndexOf("@") > 0 || new Regex(@"\d{0,}.\d{1,}Ԫ").IsMatch(tmpArr[i]))     //е   3.650Ԫ
                        {
                            tmpCodeStr += tmpArr[i].Trim();
                        }
                        i++;

                        if (i >= tmpArr.Length)
                        {
                            break;
                        }
                    }
                    i--;
                    //if (ticketEntity.L_RateType == (int)JcRateType.Fixed)
                    //{
                        dRateList.Add(string.Format("{0}{1}{2}[{3}]", strChangCi, MatchCodeSplitStr, playIdOfRate, DealRateCode(playIdOfRate,tmpCodeStr.Trim())));
                    //}
                    //else
                    //{
                    //    dCodeList.Add(string.Format("{0}{1}[{2}]", strChangCi, MatchCodeSplitStr, DealResultCode(tmpCodeStr.Trim())));
                    //}
                }
            }
            decodePrintData.L_PrintTicketEntity.L_CodeReference = string.Join(CodeSplitStr, codeReferenceList.ToArray());//
            //Ϲص
            decodePrintData.L_PrintTicketEntity.L_CodeRate = string.Join(CodeSplitStr, dRateList.ToArray());

            //Ͷע
            decodePrintData.L_PrintTicketEntity.P_Code = SplitRateDetailToCode(decodePrintData.L_PrintTicketEntity.L_CodeRate);
            #endregion

            decodePrintData.DecodeSuccess = true;
        }

        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCode(int playIdOfRate, string Istr)
        {
            string result = "";
            switch (playIdOfRate)
            {
                case 95101:
                    result = DealRateCodeRfsf(Istr);
                    break;
                case 95102:
                    result = DealRateCodeSf(Istr);
                    break;
                case 95103:
                    result = DealRateCodeSfc(Istr);
                    break;
                case 95104:
                    result = DealRateCodeDxf(Istr);
                    break;
            }
            return result;
        }
        
        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCodeRfsf(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^ʤԪ@.+\d]{1}", "");

            string tmpstr = "";
            string OneStr = "";
            for (int i = 0; i < Istr.Length; i++)
            {
                OneStr = Istr.Substring(i, 1);
                switch (OneStr)
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "@":
                        tmpstr += "#";
                        break;
                    case "ʤ":
                        tmpstr += "1";
                        break;
                    case "":
                        tmpstr += "2";
                        break;
                    case "Ԫ":
                        break;
                    default:
                        tmpstr += OneStr;
                        break;
                }
            }
            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY_RFSF, tmpstr);
            return tmpstr;
        }
        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCodeSf(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^ʤԪ@.+\d]{1}", "");

            string tmpstr = "";
            string OneStr = "";
            for (int i = 0; i < Istr.Length; i++)
            {
                OneStr = Istr.Substring(i, 1);
                switch (OneStr)
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "@":
                        tmpstr += "#";
                        break;
                    case "ʤ":
                        tmpstr += "1";
                        break;
                    case "":
                        tmpstr += "2";
                        break;
                    case "Ԫ":
                        break;
                    default:
                        tmpstr += OneStr;
                        break;
                }
            }

            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY_SF, tmpstr);

            return tmpstr;
        }

        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCodeSfc(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^()\-Ԫ@.+\d]{1}", "");

            Istr = Istr.Replace("26+", "26");
            Istr = Istr.Replace("Ԫ", "");
            string[] TmpArr = Istr.Split('+');
            string OneStr = "";
            string TmpStr = "";
            List<string> TmpList = new List<string>();
            for (int i = 0; i < TmpArr.Length; i++)
            {
                OneStr = TmpArr[i];
                string[] tmpOneArr = OneStr.Split('@');
                #region)
                switch (tmpOneArr[0])
                {
                    case "(1-5)":
                        TmpStr = "01";
                        break;
                    case "(6-10)":
                        TmpStr = "02";
                        break;
                    case "(11-15)":
                        TmpStr = "03";
                        break;
                    case "(16-20)":
                        TmpStr = "04";
                        break;
                    case "(21-25)":
                        TmpStr = "05";
                        break;
                    case "(26)":
                        TmpStr = "06";
                        break;
                    case "(1-5)":
                        TmpStr = "11";
                        break;
                    case "(6-10)":
                        TmpStr = "12";
                        break;
                    case "(11-15)":
                        TmpStr = "13";
                        break;
                    case "(16-20)":
                        TmpStr = "14";
                        break;
                    case "(21-25)":
                        TmpStr = "15";
                        break;
                    case "(26)":
                        TmpStr = "16";
                        break;
                    default:
                        break;
                }
                #endregion
                TmpList.Add(TmpStr + "#" + tmpOneArr[1]);
            }
            string tmpstr = string.Join(SplitStr, TmpList.ToArray());

            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY_SFC, tmpstr);
            return tmpstr;
        }

        /// <summary>
        /// ϸ
        /// </summary>
        /// <param name="Istr"></param>
        /// <returns></returns>
        private string DealRateCodeDxf(string Istr)
        {
            Istr = Regex.Replace(Istr, @"[^СԪ@.+\d]{1}", "");

            string tmpstr = "";
            string OneStr = "";
            for (int i = 0; i < Istr.Length; i++)
            {
                OneStr = Istr.Substring(i, 1);
                switch (OneStr)
                {
                    case "+":
                        tmpstr += SplitStr;
                        break;
                    case "@":
                        tmpstr += "#";
                        break;
                    case "":
                        tmpstr += "1";
                        break;
                    case "С":
                        tmpstr += "2";
                        break;
                    case "Ԫ":
                        break;
                    default:
                        tmpstr += OneStr;
                        break;
                }
            }
            //Ʊϵϸַ 磺2#4.700,1#1.080 Ϊ 1#1.080,2#4.700  ʹûͶעͬ
            tmpstr = SortRateText(CODE_SORT_DIECTIONRY_DXF, tmpstr);
            return tmpstr;
        }

        //ֵ 1 ʾʤ  2 ʾ
        private const string CODE_SORT_DIECTIONRY_RFSF = "1,2";
        //ֵ 1 ʾʤ  2 ʾ
        private const string CODE_SORT_DIECTIONRY_SF = "1,2";
        //ֵ 1 ʾʤ  2 ʾ
        private const string CODE_SORT_DIECTIONRY_SFC = "01,02,03,04,05,06,11,12,13,14,15,16";
        //ֵ 1 ʾ  2 ʾС
        private const string CODE_SORT_DIECTIONRY_DXF = "1,2";
        #endregion
    }
}
