using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.Common.Core.Utils;
using ChuPiao.Common.Models;

namespace ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacLotPlayMode
{
    /// <summary>
    /// ιǾ
    /// </summary>
    public class MacLotPlayModeJmGyjService : MacLotPlayModeService
    {
        public MacLotPlayModeJmGyjService()
        {
            PlayFullName = "-Ǿ";
        }
        #region Overrides of MacLotPlayModeService

        /// <summary>
        /// ͶעģʽϢ
        /// </summary>
        /// <summary>
        /// ͶעҪ͵ļб
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="machineEntity"></param>
        /// <returns></returns>
        public override List<KeycodeInfo> GetSendKeycodeList(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity)
        {
            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ʼÿζҪ淨Ͷע
            keycodeList.AddRange(GetInitKeycodeList(machineModeConfig));

            //±
            //01->[01,02,03]  01±ţΪͶע
            string[] tmpArr = ticketEntity.L_Code.Split(MatchCodeSplitStr.ToCharArray());
            string seasonnum = tmpArr[0];
            string codes = tmpArr[1].Replace("[", "").Replace("]", "");
            for (int i = 0; i < seasonnum.Length; i++)
            {
                keycodeList.Add(new KeycodeInfo(ticketEntity.L_Expect.Substring(i, 1), machineModeConfig.C_SendKeyInterval));
            }

            keycodeList.Add(new KeycodeInfo("wait", machineModeConfig.C_PrintConfirmKeyInterval));
            //Ͷע
            string[] codeArr = codes.Split(',');
            foreach (string s in codeArr)
            {
                for (int i = 0; i < s.Length; i++)
                {
                    keycodeList.Add(new KeycodeInfo(s.Substring(i, 1), machineModeConfig.C_SendKeyInterval));
                }
            }
            //Ͷעȷ
            keycodeList.Add(new KeycodeInfo(ResultEnterKey, machineModeConfig.C_SendKeyInterval));

            //Ͷ)
            if (ticketEntity.L_Mutiple > 1)
            {
                keycodeList.AddRange(GetMultipleKeycodeList(ticketEntity.L_Mutiple, machineModeConfig));
            }
            //ӡȷ
            keycodeList.Add(new KeycodeInfo(machineModeConfig.C_PrintConfirmKey, machineModeConfig.C_PrintConfirmKeyInterval));

            //Ƿ
            keycodeList.AddRange(GetPasswordKeycodeList(ticketEntity, machineEntity, machineModeConfig));

            return keycodeList;
        }

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="machineEntity"></param>
        /// <param name="decodePrintData"></param>
        /// <param name="ticketEntity"></param>
        /*public override void DecodeData(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity, DecodePrintData decodePrintData)
        {
            M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ץȡķ
            decodePrintData.L_PrintTicketEntity.P_PrnText = TicketTextUtil.CompressAndEncrypt(decodePrintData.InputData.CaptureDataBytes);

            string input = decodePrintData.InputData.CaptureDataString;
            string strTemp;
            //Ʊš롢ںŽ
            bool suc = DecodeHeadJc(ticketEntity, machineEntity, decodePrintData);
            if (!suc)
            {
                decodePrintData.ErrorMessage = string.Format("ͷ{0}", decodePrintData.ErrorMessage);
                decodePrintData.DecodeSuccess = false;
                return;
            }

            //
            Regex regex = new Regex(RegexMoney);
            Match match = regex.Match(input);
            if (!match.Success)
            {
                decodePrintData.ErrorMessage += "ûҵ";
                decodePrintData.DecodeSuccess = false;
                return;
            }
            string money = Regex.Replace(match.Value, @"\D", "");
            decodePrintData.L_PrintTicketEntity.P_Money = decimal.Parse(money);
            if (decimal.Parse(money) != ticketEntity.L_Money)
            {
                decodePrintData.ErrorMessage += string.Format("ƥ䣬{0} Ʊ{1}", ticketEntity.L_Money,
                                                              money);
                decodePrintData.DecodeSuccess = false;
                return;
            }
            //Ʊʱ
            try
            {
                regex = new Regex(RegexSucTime);
                match = regex.Match(input);
                decodePrintData.L_PrintTicketEntity.P_SucTime = DateTime.Parse(match.Value);
            }
            catch (Exception exception)
            {
                decodePrintData.ErrorMessage += string.Concat("ȡƱʱ䲻ȷϢ", exception.Message);
                decodePrintData.DecodeSuccess = false;
                return;
            }

            #region Ͷע뼰
            List<string> dCodeList = new List<string>();
            List<string> dRateList = new List<string>();
            //
            int startposition = input.IndexOf(decodePrintData.L_PrintTicketEntity.P_TicketCode) + 60;
            int endposition = input.IndexOf("*", startposition);
            if (endposition < 1)
            {
                endposition = input.IndexOf("", startposition);
            }

            strTemp = input.Substring(startposition, endposition - startposition);//Ͷעݵַ

            strTemp = Regex.Replace(strTemp, "\n", "");

            //regex = new Regex(@"\(\d{2}\s[^\)]*\)\@\d{1,}\.\d{1,}Ԫ");//(01 ¹-)@6.500Ԫ+(02 -¹)@7.500Ԫ+(03 -)@8.000Ԫ
            //رעʿΪ(39 Ӣ-ڿ)@1000Ԫ
            regex = new Regex(@"\(\d{2}\s[^\)]*\)\@\d{1,}(\.\d{1,}){0,1}Ԫ");//(01 ¹-)@6.500Ԫ+(02 -¹)@7.500Ԫ+(03 -)@8.000Ԫ

            MatchCollection matchCollection = regex.Matches(strTemp);
            foreach (Match matchCode in matchCollection)
            {
                strTemp = matchCode.Value;
                int position = strTemp.IndexOf("@");
                string code = strTemp.Substring(1, 2);
                string rateStr = strTemp.Substring(position).Replace("@", "").Replace("Ԫ", "").Replace(",","");

                if (machineModeConfig.C_IsCheckCode)
                {
                    decimal rate = 0;
                    bool result = decimal.TryParse(rateStr, out rate);
                    if (!result)
                    {
                        decodePrintData.ErrorMessage += string.Concat("ʧܣ", strTemp);
                        decodePrintData.DecodeSuccess = false;
                        return;
                    }
                }
                dCodeList.Add(code);
                dRateList.Add(string.Format("{0}#{1}", code, rateStr));
            }

            //±
            string seasonnum = ticketEntity.L_Code.Split(MatchCodeSplitStr.ToCharArray())[0];
            if (machineModeConfig.C_IsCheckCode)
            {
                //ͶעǷһ
                string tmpGetCode = string.Format("{0}[{1}]", seasonnum, string.Join(SplitStr, dCodeList.ToArray()));
                if (ticketEntity.L_Code != tmpGetCode)
                {
                    decodePrintData.ErrorMessage += string.Format("Ͷע벻ȷ,ĺǣ{0},Ʊĺǣ{1}", ticketEntity.L_Code, tmpGetCode);
                    decodePrintData.DecodeSuccess = false;
                    return;
                }
            }
            //
            decodePrintData.L_PrintTicketEntity.L_CodeRate = string.Format("{0}[{1}]", seasonnum, string.Join(SplitStr, dRateList.ToArray()));

            //Ͷע
            decodePrintData.L_PrintTicketEntity.P_Code = ticketEntity.L_Code;
            #endregion

            decodePrintData.DecodeSuccess = true;
        }
        */

        public override void DecodeData(L_LotTicketEntity ticketEntity, M_MachineEntity machineEntity, DecodePrintData decodePrintData)
        {
            M_MachineModeConfigEntity machineModeConfig = machineEntity.MachineModeConfigs[ticketEntity.MacModeId];

            //ץȡķ
            decodePrintData.L_PrintTicketEntity.P_PrnText = TicketTextUtil.CompressAndEncrypt(decodePrintData.InputData.CaptureDataBytes);

            string prnText = decodePrintData.InputData.CaptureDataString;
            try
            {
                if (prnText.Length < 1)
                {
                    throw new Exception("ƱĳΪ0");
                }
                string[] prntextArr = prnText.Split('\n');
                int startLine = -1;// ʼУйƱ
                for (int k = 0; k < prntextArr.Length; k++)
                {
                    if (prntextArr[k].Contains("йƱ"))
                    {
                        startLine = k;
                        break;
                    }
                }
                if (startLine < 0)
                {
                    throw new Exception("ûҵйƱ");
                }
                int playCodetypeLine = startLine + 1;// ʼеһΪ淨ͺͣ-ھ   ̶
                if (playCodetypeLine >= prntextArr.Length)
                {
                    throw new Exception("淨ͺͽʧ");
                }
                if (prntextArr[playCodetypeLine].IndexOf(PlayFullName, System.StringComparison.Ordinal) < 0)
                {
                    throw new Exception("淨ƥ");
                }
                string codetype = DecodeUtil.CodeTypeToString(ticketEntity.L_CodeType);
                if (prntextArr[playCodetypeLine].IndexOf(codetype, System.StringComparison.Ordinal) < 0)
                {
                    throw new Exception("Ͳƥ");
                }
                // 淨ͺ͵һΪƱţ20360571303672965633 B53BA5CC 00631957
                int ticketCodeLine = playCodetypeLine + 1;
                if (ticketCodeLine >= prntextArr.Length)
                {
                    throw new Exception("ƱŽʧ");
                }
                const string regexTicketCode = "([0-9]{20})\\s{1,}([a-zA-Z0-9\\*\\>\\<]{8})\\s{1,}([0-9]{8})";
                Match mTicketCode = new Regex(regexTicketCode).Match(prntextArr[ticketCodeLine]);
                if (!mTicketCode.Success)
                {
                    throw new Exception("ûҵƱ");
                }
                if (mTicketCode.Groups.Count != 4)
                {
                    throw new Exception("Ʊƥʧ");
                }
                string ticketCode = mTicketCode.Groups[1].Value;
                string randomCode = mTicketCode.Groups[2].Value;
                string password = mTicketCode.Groups[3].Value;
                decodePrintData.L_PrintTicketEntity.P_TicketCode = ticketCode;
                decodePrintData.L_PrintTicketEntity.P_RandomCode = randomCode;
                decodePrintData.L_PrintTicketEntity.P_Password = password;

                // ´Ͷע
                int i = ticketCodeLine;
                i++;// 
                i++;// 01	2012ŷޱ
                Regex regexSeason = new Regex(@"\d{2}");
                Match matchSeason = regexSeason.Match(prntextArr[i]);
                if (!matchSeason.Success)
                {
                    throw new Exception("±ƥʧ");
                }
                //±
                string seasonnum = matchSeason.Value;

                i++;//(01 ¹-)@6.500Ԫ+(02 -¹)@7.500Ԫ+(03 -)@8.000Ԫ
                int betContentStartLine = i;// Ͷעʼ
                int betContentEndLine = i;// Ͷעݽ
                string betContent = "";
                while (i < prntextArr.Length)
                {
                    if (prntextArr[i].Contains("ѡ̶") || prntextArr[i].Contains("*  *  *"))
                    {
                        break;
                    }
                    betContent += prntextArr[i];
                    betContentEndLine = i;
                    i++;
                }
                // αšͶӡͶע
                int betContentLineCount = betContentEndLine - betContentStartLine + 1;
                if (betContentLineCount < 1)
                {
                    throw new Exception("Ͷעݲ1");
                }
                // Ͷע
                List<string> dCodeList = new List<string>();
                List<string> dRateList = new List<string>();
                //رעʿΪ (39 Ӣ-ڿ)@1000Ԫ
                Regex regex = new Regex(@"\(\d{2}\s[^\)]*\)\@\d{1,}(\.\d{1,}){0,1}Ԫ");//(01 ¹-)@6.500Ԫ+(02 -¹)@7.500Ԫ+(03 -)@8.000Ԫ
                MatchCollection matchCollection = regex.Matches(betContent);
                foreach (Match matchCode in matchCollection)
                {
                    string strTemp = matchCode.Value;
                    int position = strTemp.IndexOf("@");
                    string code = strTemp.Substring(1, 2);
                    string rateStr = strTemp.Substring(position).Replace("@", "").Replace("Ԫ", "").Replace(",", "");

                    if (machineModeConfig.C_IsCheckCode)
                    {
                        decimal rate = 0;
                        bool result = decimal.TryParse(rateStr, out rate);
                        if (!result)
                        {
                            throw new Exception(string.Concat("ʧܣ", strTemp));
                        }
                    }
                    dCodeList.Add(code);
                    dRateList.Add(string.Format("{0}#{1}", code, rateStr));//ʸʽ01#2.000,02#2.200
                }

                if (machineModeConfig.C_IsCheckCode)
                {
                    //ͶעǷһ
                    string tmpGetCode = string.Format("{0}[{1}]", seasonnum, string.Join(SplitStr, dCodeList.ToArray()));
                    if (ticketEntity.L_Code != tmpGetCode)
                    {
                        throw new Exception(string.Format("Ͷע벻ȷ,ĺǣ{0},Ʊĺǣ{1}", ticketEntity.L_Code, tmpGetCode));
                    }
                }

                // Ʊ߿̶ܹ
                //if (ticketEntity.L_RateType == (int)JcRateType.Fixed)
                //{
                //    int maxGetMoneyLine = -1;
                //    while (i < prntextArr.Length)
                //    {
                //        if (prntextArr[i].Contains("Ʊ߿̶ܹ"))
                //        {
                //            maxGetMoneyLine = i;
                //            break;
                //        }
                //        i++;
                //    }
                //    if (maxGetMoneyLine < 0)
                //    {
                //        throw new Exception("ûҵƱ߿̶ܹ");
                //    }
                //    Match mMaxGetMoney = new Regex("Ʊ߿̶ܹ:[\\d,]{1,}(\\.\\d{1,2})?Ԫ").Match(prntextArr[maxGetMoneyLine]);
                //    if (!mMaxGetMoney.Success)
                //    {
                //        throw new Exception("Ʊ߿̶ܹƥʧ");
                //    }
                //    try
                //    {
                //        string sMaxGetMoney = mMaxGetMoney.Value.Replace("Ʊ߿̶ܹ:", "").Replace("Ԫ", "").Replace(",", "");
                //        ticketEntity.L_MaxGetMoney = decimal.Parse(sMaxGetMoney);
                //    }
                //    catch (Exception ex)
                //    {
                //        throw new Exception("Ʊ߿̶ܹ" + ex.Message);
                //    }
                //}
                int multipleLine = -1;
                while (i < prntextArr.Length)
                {
                    if (prntextArr[i].Contains(""))
                    {
                        multipleLine = i;
                        break;
                    }
                    i++;
                }
                if (multipleLine < 0)
                {
                    throw new Exception("ûҵ");
                }
                // :1 ϼ: 2Ԫ 2012-02-16 17:53:36
                const string regexMultipleMoneyTime = "[:|]\\s{0,}(\\d{1,2})\\s{1,}ϼ[:|]\\s{0,}(\\d{1,})Ԫ\\s{1,}(\\d{4}-\\d{2}-\\d{2}\\s{1,}\\d{2}:\\d{2}:\\d{2})";
                Match mMultipleMoneyTime = new Regex(regexMultipleMoneyTime).Match(prntextArr[multipleLine]);
                if (!mMultipleMoneyTime.Success)
                {
                    throw new Exception("ûҵƱʱ");
                }
                if (mMultipleMoneyTime.Groups.Count != 4)
                {
                    throw new Exception("Ʊʱƥʧ");
                }
                int multiple = int.Parse(mMultipleMoneyTime.Groups[1].Value);
                decimal money = decimal.Parse(mMultipleMoneyTime.Groups[2].Value);

                string strSucTime = Regex.Replace(mMultipleMoneyTime.Groups[3].Value, "\\s{1,}", " ");// ںʱ֮жո
                DateTime suctime;
                try
                {
                    suctime = DateTime.Parse(strSucTime);//"yyyy-MM-dd HH:mm:ss"
                }
                catch (Exception e)
                {
                    throw new Exception("Ʊʱʧܣ" + e.Message);
                }
                // Ʊʱ
                decodePrintData.L_PrintTicketEntity.P_SucTime = suctime;
                if (multiple != ticketEntity.L_Mutiple)
                {
                    throw new Exception("ƥ䣬" + ticketEntity.L_Mutiple + " Ʊ" + multiple);
                }
                if (money != ticketEntity.L_Money)
                {
                    throw new Exception("ƥ䣬" + ticketEntity.L_Money + " Ʊ" + money);
                }
                int saleAddressLine = multipleLine + 1;// һΪĻţ201415901 ˴ɽ·
                if (saleAddressLine >= prntextArr.Length)
                {
                    throw new Exception("Žʧ");
                }
                Match mZxNumber = new Regex("\\d{9}").Match(prntextArr[saleAddressLine]);
                if (!mZxNumber.Success)
                {
                    throw new Exception("ƥʧ");
                }
                //  ȥͷ2λβ2λм5λΪĻ
                string saleaddress = mZxNumber.Value.Substring(2, 5);
                decodePrintData.L_PrintTicketEntity.P_SaleAddress = saleaddress;



                //
                decodePrintData.L_PrintTicketEntity.L_CodeRate = string.Format("{0}[{1}]", seasonnum, string.Join(SplitStr, dRateList.ToArray()));

                //Ͷע
                decodePrintData.L_PrintTicketEntity.P_Code = ticketEntity.L_Code;
                decodePrintData.DecodeSuccess = true;
            }
            catch (Exception ex)
            {
                decodePrintData.ErrorMessage = ex.Message;
                decodePrintData.DecodeSuccess = false;
            }
        }

        #endregion
    }
}
