using System;
using System.Collections.Generic;
using System.IO;
using System.Threading;
using ChuPiao.AutoPrint.Machine.Models;
using ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacLotPlayMode;
using ChuPiao.AutoPrint.Machine.TjJingCaiV1.MacReport;
using ChuPiao.Common.Enums;
using ChuPiao.Common.Models;
using ChuPiao.Common.Utils;
using ChuPiao.Common.Communication.GtdJson.Packs;
using ChuPiao.Common.Communication.GtdJson;

namespace ChuPiao.AutoPrint.Machine.TjJingCaiV1
{
    /// <summary>
    /// 򾹲ʲƱ
    /// </summary>
    public class TjJingCaiMachineV1 : BaseLotMachine
    {
        #region Overrides of BaseLotMachine

        Dictionary<int, M_LotPlayModeMapEntity> _lotPlayMapList = null;
        /// <summary>
        /// 淨ӳ
        /// </summary>
        public override Dictionary<int, M_LotPlayModeMapEntity> LotPlayMap
        {
            get
            {
                if (_lotPlayMapList == null)
                {
                    _lotPlayMapList = new Dictionary<int, M_LotPlayModeMapEntity>();
                    /*M_LotPlayModeMapEntity[] playarr = new M_LotPlayModeMapEntity[49];
                    playarr[0] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110101, "ʤƽ", 911, "", 91101, "ʤƽ");
                    playarr[1] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110102, "ȷ", 911, "", 91102, "ȷ");
                    playarr[2] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110103, "ܽ", 911, "", 91103, "ܽ");
                    playarr[3] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110104, "ȫ", 911, "", 91104, "ȫ");
                    playarr[4] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110105, "÷ʤ", 951, "", 95101, "÷ʤ");
                    playarr[5] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110106, "ʤ", 951, "", 95102, "ʤ");
                    playarr[6] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110107, "ʤֲ", 951, "", 95103, "ʤֲ");
                    playarr[7] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110108, "С", 951, "", 95104, "С");
                    playarr[8] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110109, "ھ", 971, "", 97101, "ھ");
                    playarr[9] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110110, "Ǿ", 971, "", 97102, "Ǿ");
                    playarr[10] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110111, "Ϲ", 911, "", 91199, "Ϲ");
                    playarr[11] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110112, "Ϲ", 951, "", 95199, "Ϲ");

                    playarr[12] = new M_LotPlayModeMapEntity(705, "22ѡ5", 70501, "淨", 7050101, "ʽ", 705, "22ѡ5", 70501, "ʽ");
                    playarr[13] = new M_LotPlayModeMapEntity(705, "22ѡ5", 70501, "淨", 7050102, "ʽ", 705, "22ѡ5", 70502, "ʽ");
                    playarr[14] = new M_LotPlayModeMapEntity(704, "ǲ", 70401, "淨", 7040101, "ʽ", 704, "ǲ", 70401, "ʽ");
                    playarr[15] = new M_LotPlayModeMapEntity(704, "ǲ", 70401, "淨", 7040102, "ʽ", 704, "ǲ", 70402, "ʽ");
                    playarr[16] = new M_LotPlayModeMapEntity(703, "", 70301, "淨", 7030101, "ʽ", 703, "5", 70301, "ʽ");
                    playarr[17] = new M_LotPlayModeMapEntity(703, "", 70301, "淨", 7030102, "ʽ", 703, "5", 70302, "ʽ");
                    playarr[18] = new M_LotPlayModeMapEntity(702, "", 70201, "", 7020101, "ʽ", 702, "", 70201, "ֱѡʽ");
                    playarr[19] = new M_LotPlayModeMapEntity(702, "", 70201, "", 7020102, "ѡ", 702, "", 70211, "ѡʽ");
                    playarr[20] = new M_LotPlayModeMapEntity(702, "", 70201, "", 7020102, "ѡ", 702, "", 70221, "ѡʽ");
                    playarr[21] = new M_LotPlayModeMapEntity(702, "", 70201, "", 7020103, "ʽ", 702, "", 70202, "ֱѡʽ");
                    playarr[22] = new M_LotPlayModeMapEntity(702, "", 70203, "ѡ3ʽ", 7020301, "ʽ", 702, "", 70212, "ʽ");
                    playarr[23] = new M_LotPlayModeMapEntity(702, "", 70204, "ѡ6ʽ", 7020401, "ʽ", 702, "", 70222, "ʽ");
                    playarr[24] = new M_LotPlayModeMapEntity(702, "", 70205, "ֱѡֵ", 7020501, "ֵ", 702, "", 70203, "ֱѡֵ");
                    playarr[25] = new M_LotPlayModeMapEntity(702, "", 70206, "ѡֵ", 7020601, "ֵ", 702, "", 70232, "ѡֵ");
                    playarr[26] = new M_LotPlayModeMapEntity(702, "", 70207, "ֱѡϸʽ", 7020701, "ϸʽ", 702, "", 70206, "ֱѡϸʽ");
                    playarr[27] = new M_LotPlayModeMapEntity(702, "", 70208, "ֱѡϵ", 7020801, "ϵ", 702, "", 70204, "ֱѡϵ");
                    playarr[28] = new M_LotPlayModeMapEntity(702, "", 70209, "ѡ3", 7020901, "", 702, "", 70214, "");
                    playarr[29] = new M_LotPlayModeMapEntity(702, "", 70210, "ѡ6", 7021001, "", 702, "", 70224, "");
                    playarr[30] = new M_LotPlayModeMapEntity(702, "", 70211, "ֱѡȸʽ", 7021101, "", 702, "", 70205, "ֱѡ");
                    playarr[31] = new M_LotPlayModeMapEntity(702, "", 70212, "ѡ3ȸʽ", 7021201, "", 702, "", 70215, "");
                    playarr[32] = new M_LotPlayModeMapEntity(702, "", 70213, "ѡ6ȸʽ", 7021301, "", 702, "", 70225, "");
                    playarr[33] = new M_LotPlayModeMapEntity(701, "͸", 70101, "淨", 7010101, "ʽ", 701, "͸", 70101, "ʽ");
                    playarr[34] = new M_LotPlayModeMapEntity(701, "͸", 70101, "淨", 7010102, "ʽ", 701, "͸", 70102, "ʽ");
                    playarr[35] = new M_LotPlayModeMapEntity(701, "͸", 70101, "淨", 7010103, "", 701, "͸", 70103, "");
                    playarr[36] = new M_LotPlayModeMapEntity(701, "͸", 70102, "׷淨", 7010201, "ʽ", 701, "͸", 70111, "׷ӵʽ");
                    playarr[37] = new M_LotPlayModeMapEntity(701, "͸", 70102, "׷淨", 7010202, "ʽ", 701, "͸", 70112, "׷Ӹʽ");
                    playarr[38] = new M_LotPlayModeMapEntity(701, "͸", 70102, "׷淨", 7010203, "", 701, "͸", 70113, "׷ӵ");
                    playarr[39] = new M_LotPlayModeMapEntity(711, "͸˲", 71101, "淨", 7110101, "ʽ", 701, "͸", 70121, "12ѡ2ʽ");
                    playarr[40] = new M_LotPlayModeMapEntity(711, "͸˲", 71101, "淨", 7110102, "ʽ", 701, "͸", 70122, "12ѡ2ʽ");
                    playarr[41] = new M_LotPlayModeMapEntity(603, "6ȫʤ", 60301, "", 6030101, "ʽ", 603, "ȫ", 60301, "ʽ");
                    playarr[42] = new M_LotPlayModeMapEntity(603, "6ȫʤ", 60301, "", 6030102, "ʽ", 603, "ȫ", 60302, "ʽ");
                    playarr[43] = new M_LotPlayModeMapEntity(602, "4", 60201, "ĳ", 6020101, "ʽ", 602, "ĳ", 60201, "ʽ");
                    playarr[44] = new M_LotPlayModeMapEntity(602, "4", 60201, "ĳ", 6020102, "ʽ", 602, "ĳ", 60202, "ʽ");
                    playarr[45] = new M_LotPlayModeMapEntity(601, "ʤƽ", 60101, "ʮĳ", 6010101, "ʽ", 601, "ʤ", 60101, "ʮĳʽ");
                    playarr[46] = new M_LotPlayModeMapEntity(601, "ʤƽ", 60101, "ʮĳ", 6010102, "ʽ", 601, "ʤ", 60102, "ʮĳʽ");
                    playarr[47] = new M_LotPlayModeMapEntity(611, "ѡ9", 61101, "ų", 6110101, "ʽ", 601, "ʤ", 60111, "ųʽ");
                    playarr[48] = new M_LotPlayModeMapEntity(611, "ѡ9", 61101, "ų", 6110102, "ʽ", 601, "ʤ", 60112, "ųʽ");*/
                    M_LotPlayModeMapEntity[] playarr = new M_LotPlayModeMapEntity[81];
                    playarr[0] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110101, "ʤƽ", 911, "", 91106, "ʤƽ");
                    playarr[1] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110102, "ȷ", 911, "", 91102, "ȷ");
                    playarr[2] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110103, "ܽ", 911, "", 91103, "ܽ");
                    playarr[3] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110104, "ȫ", 911, "", 91104, "ȫ");
                    playarr[4] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110105, "÷ʤ", 951, "", 95101, "÷ʤ");
                    playarr[5] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110106, "ʤ", 951, "", 95102, "ʤ");
                    playarr[6] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110107, "ʤֲ", 951, "", 95103, "ʤֲ");
                    playarr[7] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110108, "С", 951, "", 95104, "С");
                    playarr[8] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110109, "ھ", 971, "", 97101, "ھ");
                    playarr[9] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110110, "Ǿ", 971, "", 97102, "Ǿ");
                    playarr[10] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110111, "Ϲ", 911, "", 91199, "Ϲ");
                    playarr[11] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110112, "Ϲ", 951, "", 95199, "Ϲ");
                    playarr[12] = new M_LotPlayModeMapEntity(911, "", 91101, "淨", 9110113, "ʤƽ", 911, "", 91101, "ʤƽ");

                    playarr[13] = new M_LotPlayModeMapEntity(705, "22ѡ5", 70501, "淨", 7050101, "ʽ", 705, "22ѡ5", 70501, "ʽ");
                    playarr[14] = new M_LotPlayModeMapEntity(705, "22ѡ5", 70501, "淨", 7050102, "ʽ", 705, "22ѡ5", 70502, "ʽ");
                    playarr[15] = new M_LotPlayModeMapEntity(704, "7ǲ", 70401, "淨", 7040101, "ʽ", 704, "7ǲ", 70401, "ʽ");
                    playarr[16] = new M_LotPlayModeMapEntity(704, "7ǲ", 70401, "淨", 7040102, "ʽ", 704, "7ǲ", 70402, "ʽ");

                    playarr[17] = new M_LotPlayModeMapEntity(703, "", 70301, "淨", 7030101, "ʽ", 703, "5", 70301, "ʽ");
                    playarr[18] = new M_LotPlayModeMapEntity(703, "", 70301, "淨", 7030102, "ʽ", 703, "5", 70302, "ʽ");
                    playarr[19] = new M_LotPlayModeMapEntity(702, "", 70201, "", 7020101, "ʽ", 702, "", 70201, "ֱѡʽ");
                    playarr[20] = new M_LotPlayModeMapEntity(702, "", 70201, "", 7020102, "ѡ", 702, "", 70211, "ѡʽ");
                    playarr[21] = new M_LotPlayModeMapEntity(702, "", 70201, "", 7020102, "ѡ", 702, "", 70221, "ѡʽ");
                    playarr[22] = new M_LotPlayModeMapEntity(702, "", 70201, "", 7020103, "ʽ", 702, "", 70202, "ֱѡʽ");
                    playarr[23] = new M_LotPlayModeMapEntity(702, "", 70203, "ѡ3ʽ", 7020301, "ʽ", 702, "", 70212, "ʽ");
                    playarr[24] = new M_LotPlayModeMapEntity(702, "", 70204, "ѡ6ʽ", 7020401, "ʽ", 702, "", 70222, "ʽ");
                    playarr[25] = new M_LotPlayModeMapEntity(702, "", 70205, "ֱѡֵ", 7020501, "ֵ", 702, "", 70203, "ֱѡֵ");
                    playarr[26] = new M_LotPlayModeMapEntity(702, "", 70206, "ѡֵ", 7020601, "ֵ", 702, "", 70232, "ѡֵ");
                    playarr[27] = new M_LotPlayModeMapEntity(702, "", 70207, "ֱѡϸʽ", 7020701, "ϸʽ", 702, "", 70206, "ֱѡϸʽ");
                    playarr[28] = new M_LotPlayModeMapEntity(702, "", 70208, "ֱѡϵ", 7020801, "ϵ", 702, "", 70204, "ֱѡϵ");
                    playarr[29] = new M_LotPlayModeMapEntity(702, "", 70209, "ѡ3", 7020901, "", 702, "", 70214, "");
                    playarr[30] = new M_LotPlayModeMapEntity(702, "", 70210, "ѡ6", 7021001, "", 702, "", 70224, "");
                    playarr[31] = new M_LotPlayModeMapEntity(702, "", 70211, "ֱѡȸʽ", 7021101, "", 702, "", 70205, "ֱѡ");
                    playarr[32] = new M_LotPlayModeMapEntity(702, "", 70212, "ѡ3ȸʽ", 7021201, "", 702, "", 70215, "");
                    playarr[33] = new M_LotPlayModeMapEntity(702, "", 70213, "ѡ6ȸʽ", 7021301, "", 702, "", 70225, "");

                    playarr[34] = new M_LotPlayModeMapEntity(701, "͸", 70101, "淨", 7010101, "ʽ", 701, "͸", 70101, "ʽ");
                    playarr[35] = new M_LotPlayModeMapEntity(701, "͸", 70101, "淨", 7010102, "ʽ", 701, "͸", 70102, "ʽ");
                    playarr[36] = new M_LotPlayModeMapEntity(701, "͸", 70101, "淨", 7010103, "", 701, "͸", 70103, "");
                    playarr[37] = new M_LotPlayModeMapEntity(701, "͸", 70102, "׷淨", 7010201, "ʽ", 701, "͸", 70111, "׷ӵʽ");
                    playarr[38] = new M_LotPlayModeMapEntity(701, "͸", 70102, "׷淨", 7010202, "ʽ", 701, "͸", 70112, "׷Ӹʽ");
                    playarr[39] = new M_LotPlayModeMapEntity(701, "͸", 70102, "׷淨", 7010203, "", 701, "͸", 70113, "׷ӵ");
                    playarr[40] = new M_LotPlayModeMapEntity(711, "͸˲", 71101, "淨", 7110101, "ʽ", 701, "͸", 70121, "12ѡ2ʽ");
                    playarr[41] = new M_LotPlayModeMapEntity(711, "͸˲", 71101, "淨", 7110102, "ʽ", 701, "͸", 70122, "12ѡ2ʽ");
                    playarr[42] = new M_LotPlayModeMapEntity(603, "6ȫʤ", 60301, "", 6030101, "ʽ", 603, "ȫ", 60301, "ʽ");
                    playarr[43] = new M_LotPlayModeMapEntity(603, "6ȫʤ", 60301, "", 6030102, "ʽ", 603, "ȫ", 60302, "ʽ");
                    playarr[44] = new M_LotPlayModeMapEntity(602, "4", 60201, "ĳ", 6020101, "ʽ", 602, "ĳ", 60201, "ʽ");
                    playarr[45] = new M_LotPlayModeMapEntity(602, "4", 60201, "ĳ", 6020102, "ʽ", 602, "ĳ", 60202, "ʽ");
                    playarr[46] = new M_LotPlayModeMapEntity(601, "ʤƽ", 60101, "ʮĳ", 6010101, "ʽ", 601, "ʤ", 60101, "ʮĳʽ");
                    playarr[47] = new M_LotPlayModeMapEntity(601, "ʤƽ", 60101, "ʮĳ", 6010102, "ʽ", 601, "ʤ", 60102, "ʮĳʽ");
                    playarr[48] = new M_LotPlayModeMapEntity(611, "ѡ9", 61101, "ų", 6110101, "ʽ", 601, "ʤ", 60111, "ųʽ");
                    playarr[49] = new M_LotPlayModeMapEntity(611, "ѡ9", 61101, "ų", 6110102, "ʽ", 601, "ʤ", 60112, "ųʽ");

                    playarr[50] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50301, "ѡһ", 5030102, "ʽ", 503, "11ѡ5", 50301, "ǰ1ֱѡʽ");
                    playarr[51] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50301, "ѡһ", 5030102, "ʽ", 503, "11ѡ5", 50351, "ǰ1ֱѡʽ");
                    playarr[52] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50302, "ѡ", 5030201, "ʽ", 503, "11ѡ5", 50322, "ѡ2ʽ");
                    playarr[53] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50302, "ѡ", 5030202, "ʽ", 503, "11ѡ5", 50372, "ѡ2ʽ");
                    playarr[54] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50302, "ѡ", 5030203, "", 503, "11ѡ5", 50342, "ѡ2");
                    playarr[55] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50303, "ѡ", 5030301, "ʽ", 503, "11ѡ5", 50323, "ѡ3ʽ");
                    playarr[56] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50303, "ѡ", 5030302, "ʽ", 503, "11ѡ5", 50373, "ѡ3ʽ");
                    playarr[57] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50303, "ѡ", 5030303, "", 503, "11ѡ5", 50343, "ѡ3");
                    playarr[58] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50304, "ѡ", 5030401, "ʽ", 503, "11ѡ5", 50324, "ѡ4ʽ");
                    playarr[59] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50304, "ѡ", 5030402, "ʽ", 503, "11ѡ5", 50374, "ѡ4ʽ");
                    playarr[60] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50304, "ѡ", 5030403, "", 503, "11ѡ5", 50344, "ѡ4");
                    playarr[61] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50305, "ѡ", 5030501, "ʽ", 503, "11ѡ5", 50325, "ѡ5ʽ");
                    playarr[62] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50305, "ѡ", 5030502, "ʽ", 503, "11ѡ5", 50375, "ѡ5ʽ");
                    playarr[63] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50305, "ѡ", 5030503, "", 503, "11ѡ5", 50345, "ѡ5");
                    playarr[64] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50306, "ѡ", 5030601, "ʽ", 503, "11ѡ5", 50326, "ѡ6ʽ");
                    playarr[65] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50306, "ѡ", 5030602, "ʽ", 503, "11ѡ5", 50376, "ѡ6ʽ");
                    playarr[66] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50306, "ѡ", 5030603, "", 503, "11ѡ5", 50346, "ѡ6");
                    playarr[67] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50307, "ѡ", 5030701, "ʽ", 503, "11ѡ5", 50327, "ѡ7ʽ");
                    playarr[68] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50307, "ѡ", 5030702, "ʽ", 503, "11ѡ5", 50377, "ѡ7ʽ");
                    playarr[69] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50307, "ѡ", 5030703, "", 503, "11ѡ5", 50347, "ѡ7");
                    playarr[70] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50308, "ѡ", 5030801, "ʽ", 503, "11ѡ5", 50328, "ѡ8ʽ");
                    playarr[71] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50309, "ѡǰѡ", 5030901, "ʽ", 503, "11ѡ5", 50312, "ǰ2ѡʽ");
                    playarr[72] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50309, "ѡǰѡ", 5030902, "ʽ", 503, "11ѡ5", 50362, "ǰ2ѡʽ");
                    playarr[73] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50309, "ѡǰѡ", 5030903, "", 503, "11ѡ5", 50332, "ǰ2ѡ");
                    playarr[74] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50310, "ѡǰֱѡ", 5031001, "ʽ", 503, "11ѡ5", 50302, "ǰ2ֱѡʽ");
                    playarr[75] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50310, "ѡǰֱѡ", 5031003, "λʽ", 503, "11ѡ5", 50352, "ǰ2ֱѡλʽ");
                    playarr[76] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50311, "ѡǰѡ", 5031101, "ʽ", 503, "11ѡ5", 50313, "ǰ3ѡʽ");
                    playarr[77] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50311, "ѡǰѡ", 5031102, "ʽ", 503, "11ѡ5", 50363, "ǰ3ѡʽ");
                    playarr[78] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50311, "ѡǰѡ", 5031103, "", 503, "11ѡ5", 50333, "ǰ3ѡ");
                    playarr[79] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50312, "ѡǰֱѡ", 5031201, "ʽ", 503, "11ѡ5", 50303, "ǰ3ֱѡʽ");
                    playarr[80] = new M_LotPlayModeMapEntity(503, "11ѡ5", 50312, "ѡǰֱѡ", 5031203, "λʽ", 503, "11ѡ5", 50353, "ǰ3ֱѡλʽ");

                    foreach (M_LotPlayModeMapEntity entity in playarr)
                    {
                        _lotPlayMapList.Add(entity.M_PlayId, entity);
                    }
                }
                return _lotPlayMapList;
            }
        }

        /// <summary>
        /// Ʊʼ
        /// </summary>
        public override void Initialize()
        {
            try
            {

                if (MachineInfo.M_KeyboardType == (int)KeyboardType.NewKeyboard)
                {
                    VirtualKeyboard = new VirtualKeyboardV2(MachineInfo.M_VirtualKeyboardPort,
                                                             MachineInfo.M_VirtualKeyboardPortBps);
                }
                else if (MachineInfo.M_KeyboardType == (int)KeyboardType.OldKeyboard)
                {
                    VirtualKeyboard = new VirtualKeyboardV1(MachineInfo.M_VirtualKeyboardPort,
                                                             MachineInfo.M_VirtualKeyboardPortBps);
                }

                //VirtualScanner = new VirtualScanner(MachineInfo.M_VirtualScannerPort,MachineInfo.M_VirtualScannerPortBps);

                VirtualPrinter = new VirtualPrinter(MachineInfo.M_VirtualPrinterPort,
                                                         MachineInfo.M_VirtualPrinterPortBps);
                VirtualKeyboard.Log = Log;
                VirtualKeyboard.Port = MachineInfo.M_VirtualKeyboardPort;
                VirtualKeyboard.PortBps = MachineInfo.M_VirtualKeyboardPortBps;
                VirtualKeyboard.KeyboardType = (KeyboardType)MachineInfo.M_KeyboardType;
                VirtualKeyboard.MachineInfo = MachineInfo;
                //VirtualScanner.Log = Log;
                //VirtualScanner.Port = MachineInfo.M_VirtualScannerPort;
                //VirtualScanner.PortBps = MachineInfo.M_VirtualScannerPortBps;
                //VirtualScanner.MachineInfo = MachineInfo;
                VirtualPrinter.Log = Log;
                VirtualPrinter.LogPath = Path.Combine(@"D:\data\logs", MachineInfo.M_Number + @"\");
                VirtualPrinter.Port = MachineInfo.M_VirtualPrinterPort;
                VirtualPrinter.PortBps = MachineInfo.M_VirtualPrinterPortBps;
                VirtualPrinter.MachineInfo = MachineInfo;
                VirtualPrinter.LotMachine = this;
                VirtualPrinter.LastPrintCounter = MachineInfo.M_LastPrintCounter;

                VirtualKeyboard.Initialize();
                //VirtualScanner.Initialize();
                VirtualPrinter.Initialize();
            }
            catch (Exception exception)
            {
                Log.Warn(string.Concat("Ʊʼ쳣Ϣ", exception));
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public override void StartDriver()
        {
            VirtualPrinter.Start();
            VirtualKeyboard.Start();
            //VirtualScanner.Start();
        }

        /// <summary>
        /// ֹͣ
        /// </summary>
        public override void StopDriver()
        {
            VirtualKeyboard.Stop();
            VirtualPrinter.Stop();
            //VirtualScanner.Stop();
        }

        /// <summary>
        /// 
        /// </summary>
        public override void ReStartDriver()
        {
            if (MachineInfo.M_Status != (int)MachineStatusEnum.Stopped)
            {
                Log.Info("ֹͣ״̬Ļֹ");
                return;
            }
            StopDriver();
            int wait = 0;
            while (wait < 3000)
            {
                if (VirtualKeyboard.Status == VirtualKeyboardStatus.Stopped && VirtualPrinter.Status == VirtualPrinterStatus.Stopped)
                {
                    break;
                }
                wait += 100;
                Thread.Sleep(100);
            }
            Initialize();//³ʼ
            StartDriver();
        }
        public M_LotPlayModeMapEntity GetLotPlayMapByPlayId(int playId)
        {
            return LotPlayMap[playId];
        }


        /// <summary>
        /// ӡָƱ
        /// </summary>
        public override void Print(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData)
        {
            //жǰһƱǷһ
            bool isSame = false;
            if ((ticketEntity.LotId == (int)Lottype.Jz || ticketEntity.LotId == (int)Lottype.Jl) && LastSucTicket != null && ticketEntity.L_Money == LastSucTicket.L_Money && ticketEntity.L_PlayId == LastSucTicket.L_PlayId && ticketEntity.L_Code == LastSucTicket.L_Code &&
                ticketEntity.L_CodeType == LastSucTicket.L_CodeType && ticketEntity.L_Mutiple == LastSucTicket.L_Mutiple && ticketEntity.L_Expect == LastSucTicket.L_Expect && ticketEntity.L_CurrentExpect == LastSucTicket.L_CurrentExpect)
            {
                isSame = true;
                Log.Info("һƱһ£");
            }

            CurrentTicket = ticketEntity;

            M_LotPlayModeMapEntity lotPlayMap = GetLotPlayMapByPlayId(ticketEntity.L_PlayId);
            ticketEntity.MacLotId = lotPlayMap.M_MacLotId;
            ticketEntity.MacPlayId = lotPlayMap.M_MacPlayId;
            ticketEntity.MacModeId = lotPlayMap.M_MacModeId;

            //л淨
            SetCurrentLotPlayMode(ticketEntity);

            Log.Info(string.Concat("ˮţ", ticketEntity.L_TicketSn, " ֣", ticketEntity.L_LotName, ticketEntity.LotId, " 淨", ticketEntity.L_PlayName, ticketEntity.L_PlayId, " ʼƱ"));
            //Log.Info("ʼģӡ"+ticketEntity.L_TicketSn);
            //PrintPayMoneyReport(new DecodeMachinePayMoneyReport());
            //մӡջ
            VirtualPrinter.ClearBuffer();
            MacLotPlayModeServiceFactory modeServiceFactory = new MacLotPlayModeServiceFactory();
            IMacLotPlayModeService modeService = modeServiceFactory.GetLotPlayService(ticketEntity.MacModeId);


            //̳Ʊ
            //ȴͼб
            List<KeycodeInfo> keycodeInfoList;
            if (!isSame)
            {
                keycodeInfoList = modeService.GetSendKeycodeList(ticketEntity, MachineInfo);
            }
            else
            {
                keycodeInfoList = new List<KeycodeInfo>();
                keycodeInfoList.Add(new KeycodeInfo("enter", MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                keycodeInfoList.Add(new KeycodeInfo("wait500", MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                keycodeInfoList.Add(new KeycodeInfo("f7", MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                keycodeInfoList.Add(new KeycodeInfo("wait500", MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                keycodeInfoList.Add(new KeycodeInfo("enter", MachineInfo.MachineConfigEntity.C_SendCommandInterval));

                //Ƿ
                keycodeInfoList.AddRange(modeService.GetPasswordKeycodeList(ticketEntity, MachineInfo));
            }


            //üӼ
            if (LocalConfigUtil.KeyInterval != 0)
            {
                Random random = new Random();
                int min = LocalConfigUtil.KeyInterval - 50;
                int max = LocalConfigUtil.KeyInterval + 50;
                foreach (KeycodeInfo ki in keycodeInfoList)
                {

                    ki.SendInterval += random.Next(min, max);
                }
            }

            //Եʱע⣬ֱһƱѾƱ
            VirtualKeyboard.Input(keycodeInfoList);

            decodePrintData.InputData = VirtualPrinter.Output();

            modeService.DecodeData(ticketEntity, MachineInfo, decodePrintData);

            //TODO TEST
            //JcTicketSimulator.Build(ticketEntity,decodePrintData);
            if (decodePrintData.DecodeSuccess)
            {
                ticketEntity.L_TicketCode = decodePrintData.L_PrintTicketEntity.P_TicketCode;
                ticketEntity.L_RandomCode = decodePrintData.L_PrintTicketEntity.P_RandomCode;
                ticketEntity.L_Password = decodePrintData.L_PrintTicketEntity.P_Password;
                ticketEntity.L_SucTime = decodePrintData.L_PrintTicketEntity.P_SucTime;
                ticketEntity.L_SaleAddress = decodePrintData.L_PrintTicketEntity.P_SaleAddress;
                ticketEntity.L_CodeRate = decodePrintData.L_PrintTicketEntity.L_CodeRate;
                ticketEntity.L_MaxGetMoney = decodePrintData.L_PrintTicketEntity.L_MaxGetMoney;
                ticketEntity.L_CodeReference = decodePrintData.L_PrintTicketEntity.L_CodeReference;
                ticketEntity.L_Status = (int)TicketStatus.Suc;
                ticketEntity.L_LimitType = 0;

                LastSucTicket = CurrentTicket;

                //Ʊɹ
                ClearBuffer();
                //Wait(500);
            }
            Log.Debug(string.Concat("ˮţ", ticketEntity.L_TicketSn, " Print"));
        }

        /// <summary>
        /// »ȡ
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="decodePrintData"></param>
        public override void ReGetdata(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData)
        {
            MacLotPlayModeServiceFactory modeServiceFactory = new MacLotPlayModeServiceFactory();
            IMacLotPlayModeService modeService = modeServiceFactory.GetLotPlayService(ticketEntity.MacModeId);
            decodePrintData.InputData = VirtualPrinter.ReOutput();
            modeService.DecodeData(ticketEntity, MachineInfo, decodePrintData);
            if (decodePrintData.DecodeSuccess)
            {
                ticketEntity.L_TicketCode = decodePrintData.L_PrintTicketEntity.P_TicketCode;
                ticketEntity.L_RandomCode = decodePrintData.L_PrintTicketEntity.P_RandomCode;
                ticketEntity.L_Password = decodePrintData.L_PrintTicketEntity.P_Password;
                ticketEntity.L_SucTime = decodePrintData.L_PrintTicketEntity.P_SucTime;
                ticketEntity.L_SaleAddress = decodePrintData.L_PrintTicketEntity.P_SaleAddress;
                ticketEntity.L_CodeRate = decodePrintData.L_PrintTicketEntity.L_CodeRate;
                ticketEntity.L_MaxGetMoney = decodePrintData.L_PrintTicketEntity.L_MaxGetMoney;
                ticketEntity.L_CodeReference = decodePrintData.L_PrintTicketEntity.L_CodeReference;
                ticketEntity.L_Status = (int)TicketStatus.Suc;
                ticketEntity.L_LimitType = 0;
                ticketEntity.L_PrnText = decodePrintData.L_PrintTicketEntity.P_PrnText;
                ticketEntity.L_NotifyStatus = (int)NotifyStatus.NotifyAble;

                LastSucTicket = CurrentTicket;
            }
        }

        /// <summary>
        /// ԵƱ
        /// </summary>
        /// <param name="ticketEntity"></param>
        /// <param name="decodePrintData"></param>
        public override void TestDecodeTicket(L_LotTicketEntity ticketEntity, DecodePrintData decodePrintData)
        {
            MacLotPlayModeServiceFactory modeServiceFactory = new MacLotPlayModeServiceFactory();
            IMacLotPlayModeService modeService = modeServiceFactory.GetLotPlayService(ticketEntity.MacModeId);
            modeService.DecodeData(ticketEntity, MachineInfo, decodePrintData);
        }



        /// <summary>
        /// ȡƱ
        /// </summary>
        /// <returns></returns>
        public override CaptureDataInfo GetCacheTicket()
        {
            return null;
        }

        /// <summary>
        /// ȡһƱ
        /// </summary>
        /// <returns></returns>
        public override CaptureDataInfo GetLastTicket()
        {
            return null;
        }

        /// <summary>
        /// ҽָƱ
        /// </summary>
        /// <param name="ticketEntity"></param>
        public override void Encash(L_LotTicketEntity ticketEntity)
        {
            /*DecodeMachineReport decodeMachineReport;
            if (!LastEncashSuc || LastMachineReport == null)
            {
                //ӡ
                decodeMachineReport = new DecodeMachineReport();
                for (int i = 0; i < 3; i++)
                {
                    this.PrintCurrentDayReport(decodeMachineReport);
                    if (decodeMachineReport.DecodeSuccess)
                    {
                        break;
                    }
                    else
                    {
                        Log.Info(string.Concat("ӡʧܣ", decodeMachineReport.ErrorMessage));
                    }
                }
                if (decodeMachineReport.DecodeSuccess)
                {
                    LastMachineReport = decodeMachineReport.MachineReportEntity;
                }
                else
                {
                    Log.Warn(string.Concat("ӡʧܣ", decodeMachineReport.ErrorMessage));
                    return;
                }
            }*/

            OnEncashing(ticketEntity);
            //Log.Info("ʼģҽ" + ticketEntity.L_TicketSn);
            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            int waittime = 1000;    //1뻺

            //ҽǰ
            //for (int i = 0; i < MachineInfo.MachineConfigEntity.C_BeforeEncashKeys.Length; i++)
            //{
            //    keycodeList.Add(new KeycodeInfo(MachineInfo.MachineConfigEntity.C_BeforeEncashKeys.Substring(i, 1), MachineInfo.MachineConfigEntity.C_SendCommandInterval));
            //}
            if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_BeforeEncashKeys))
            {
                foreach (string key in MachineInfo.MachineConfigEntity.C_BeforeEncashKeys.Split(','))
                {
                    keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval, true));
                }
            }
            //Ʊ
            for (int i = 0; i < ticketEntity.L_TicketCode.Length; i++)
            {
                keycodeList.Add(new KeycodeInfo(ticketEntity.L_TicketCode.Substring(i, 1), MachineInfo.MachineConfigEntity.C_SendKeyInterval, true));
            }
            //ƱŲ24λֻ20λԶ򣬿԰right
            keycodeList.Add(new KeycodeInfo("right", MachineInfo.MachineConfigEntity.C_SendKeyInterval, true));
            //
            for (int i = 0; i < ticketEntity.L_Password.Length; i++)
            {
                keycodeList.Add(new KeycodeInfo(ticketEntity.L_Password.Substring(i, 1), MachineInfo.MachineConfigEntity.C_SendKeyInterval, true));
            }
            //ҽȷ
            //if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_AfterEncashKeys))
            //{
            //    foreach (string key in MachineInfo.MachineConfigEntity.C_AfterEncashKeys.Split(','))
            //    {
            //        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
            //    }
            //}
            if (ticketEntity.EncashOption == 1)
            {
                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_AfterEncashKeysNoReturn))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_AfterEncashKeysNoReturn.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval, true));
                    }
                }
            }
            else
            {
                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_AfterEncashKeys))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_AfterEncashKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval, true));
                    }
                }
            }
            //ȴ
            //keycodeList.Add(new KeycodeInfo("wait", 1000));
            this.VirtualKeyboard.Input(keycodeList);
            waittime += SendKeysTime(keycodeList);
            Log.Info(string.Concat("ȴ", waittime, ""));
            Thread.Sleep(waittime);

            MacCurrentMode = null;
            MacCurrentExpect = null;

            //ӡ
            /*decodeMachineReport = new DecodeMachineReport();
            for (int i = 0; i < 3; i++)
            {
                this.PrintCurrentDayReport(decodeMachineReport);
                if (decodeMachineReport.DecodeSuccess)
                {
                    break;
                }
                else
                {
                    Log.Info(string.Concat("ӡʧܣ", decodeMachineReport.ErrorMessage));
                }
            }
            if (decodeMachineReport.DecodeSuccess)
            {
                R_MachineReportEntity currentMachineReport = decodeMachineReport.MachineReportEntity;

                Log.Info(string.Concat("һα ѶҽƱ", LastMachineReport.R_EncashTicket, " Ѷҽ", LastMachineReport.R_EncashMoney, "ǰ ѶҽƱ", currentMachineReport.R_EncashTicket, " Ѷҽ", currentMachineReport.R_EncashMoney));
                if (currentMachineReport.R_EncashTicket == LastMachineReport.R_EncashTicket + 1 && currentMachineReport.R_EncashMoney == LastMachineReport.R_EncashMoney + ticketEntity.L_GetMoney)
                {
                    //ҽɹ
                    ticketEntity.L_EncashStatus = (int)EncashStatus.Success;
                    JcL_LotTicketService lotTicketService = new JcL_LotTicketService();
                    lotTicketService.SetTicketEncashed(ticketEntity);
                    Log.Info(string.Concat("ˮţ", ticketEntity.L_TicketSn, "ҽɹ"));
                }
                LastMachineReport = currentMachineReport;
            }
            else
            {
                Log.Warn(string.Concat("ӡʧܣ", decodeMachineReport.ErrorMessage));
                return;
            }*/

            OnEncashed(ticketEntity);
        }

        /// <summary>
        /// ӡɿ
        /// </summary>
        /// <param name="isPaperOut">Ƿֽ</param>
        /// <param name="decodePrintData"></param>
        public override void PrintPayMoneyReport(DecodeMachinePayMoneyReport decodePrintData, bool isPaperOut)
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷ӡɿ");
                    return;
                }

                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();

                if (!MachineInfo.M_HasJc)
                {
                    MachineInfo.MachineConfigEntity.C_UpdateMoneyKeys = MachineInfo.MachineConfigEntity.C_UpdateMoneyKeys.Replace(",0,9,", ",0,8,");
                }

                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_UpdateMoneyKeys))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_UpdateMoneyKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                VirtualPrinter.ClearBuffer();


                VirtualKeyboard.Input(keycodeList);
                decodePrintData.InputData = VirtualPrinter.Output();
                if (isPaperOut)
                {
                    //PrinterClient.AddBytes(decodePrintData.InputData.CaptureDataBytes);
                }
                MacReportService macReportService = new MacReportService();
                macReportService.DecodeMachinePayMoneyReport(MachineInfo, decodePrintData);

                ReturnTopGui();
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ӡɿ", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                //return (int)(WcfCodeEnum.UpdateMahineMoneyException);
                decodePrintData.ErrorMessage += ex.Message;
                //return decodePrintData;
            }
        }

        /// <summary>
        /// ӡʱαʵϴľʱα
        /// </summary>
        /// <returns></returns>
        public override void PrintReport(DateTime startTime, DateTime endTime, DecodeMachineReport decodePrintData, bool isPaperOut)
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷ӡʱα");
                    return;
                }

                MacReportService macReportService = new MacReportService();
                List<KeycodeInfo> keycodeInfoList = macReportService.GetMachineReportKeycodeList(MachineInfo, startTime, endTime);
                //մӡջ
                VirtualPrinter.ClearBuffer();

                VirtualKeyboard.Input(keycodeInfoList);
                decodePrintData.InputData = VirtualPrinter.Output();
                if (isPaperOut)
                {
                    //PrinterClient.AddBytes(decodePrintData.InputData.CaptureDataBytes);
                }
                macReportService.DecodeMachineReportReport(MachineInfo, decodePrintData);

                ReturnTopGui();
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ӡʱα", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                throw new Exception(ex.Message);
            }
        }

        /// <summary>
        /// ӡʻ
        /// </summary>
        /// <returns></returns>
        public override void PrintJcReport(DateTime startTime, DateTime endTime, DecodeMachineReport decodePrintData, bool isPaperOut)
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷ӡʱα");
                    return;
                }

                //MacReportService macReportService = new MacReportService();
                //Common.Communication.CpdJson.Packs.P12020PrintJcTimeReport reqPack = new Common.Communication.CpdJson.Packs.P12020PrintJcTimeReport();
                //reqPack.MacNumber = MachineInfo.M_Number;
                //reqPack.StartTime = startTime;
                //reqPack.EndTime = endTime;
                //reqPack.IsPaperOut = isPaperOut;
                //Common.Communication.CpdJson.PackRetBase packRetBase = Common.Communication.CpdJson.PackManager.Instance.Transaction(MachineInfo.M_Number, reqPack, Log);
                //if (packRetBase == null)
                //{
                //    throw new Exception(string.Concat("ӡʱαʧܡţ", MachineInfo.M_Number));
                //}
                //if (packRetBase.ReturnCode != 0)
                //{
                //    throw new Exception(string.Concat("Ʊش룺", packRetBase.ReturnCode, " Ϣ", packRetBase.ReturnMessage));
                //}
                //Common.Communication.CpdJson.Packs.P12020PrintJcTimeReportRet resPack = packRetBase as Common.Communication.CpdJson.Packs.P12020PrintJcTimeReportRet;
                //if (resPack == null)
                //{
                //    throw new Exception(string.Concat("ӡʱαʧܡţ", MachineInfo.M_Number));
                //}
                //decodePrintData.InputData = new CaptureDataInfo(resPack.PrnText.Length > 0 ? HexStringUtil.StringToByte(resPack.PrnText) : new byte[] { });
                //if (decodePrintData.InputData.CaptureDataBytes.Length > 0)
                //{
                //    this.VirtualPrinter.SaveLastFile(decodePrintData.InputData.CaptureDataBytes);
                //}

                MacReportService macReportService = new MacReportService();
                List<KeycodeInfo> keycodeInfoList = macReportService.GetJcMachineReportKeycodeList(MachineInfo, startTime, endTime);
                //մӡջ
                VirtualPrinter.ClearBuffer();

                VirtualKeyboard.Input(keycodeInfoList);
                decodePrintData.InputData = VirtualPrinter.Output();
                if (isPaperOut)
                {
                    //PrinterClient.AddBytes(decodePrintData.InputData.CaptureDataBytes);
                }

                macReportService.DecodeMachineReportReport(MachineInfo, decodePrintData);
                //if (!decodePrintData.DecodeSuccess)
                //{
                //    macReportService.DecodeMachineReportReport(MachineInfo, decodePrintData);
                //}
                Log.Info(string.Concat("ӡʱαɣDecodeSuccess", decodePrintData.DecodeSuccess + " DecodeMessage:" + decodePrintData.ErrorMessage));

                ReturnTopGui();
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ӡʱα", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                throw new Exception(ex.Message);
            }
        }
        public override void PrintCurrentDayReport(DecodeMachineReport decodePrintData, bool isPaperOut)
        {
            DateTime now = DateTime.Now;
            DateTime startTime = new DateTime(now.Year, now.Month, now.Day);
            DateTime endTime = startTime;
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status == MachineStatusEnum.Printing)
                {
                    Log.Info("ƱеĻ޷ӡʱα");
                    return;
                }

                MacReportService macReportService = new MacReportService();
                List<KeycodeInfo> keycodeInfoList = macReportService.GetMachineReportKeycodeList(MachineInfo, startTime, endTime);
                //մӡջ
                VirtualPrinter.ClearBuffer();

                VirtualKeyboard.Input(keycodeInfoList);
                decodePrintData.InputData = VirtualPrinter.Output();
                macReportService.DecodeMachineReportReport(MachineInfo, decodePrintData);

                MacCurrentMode = null;
                MacCurrentExpect = null;
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ӡʱα", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                throw new Exception(ex.Message);
            }
        }

        /// <summary>
        /// ӡ淨
        /// </summary>
        /// <returns></returns>
        public override void PrintPlayReport(M_PlayTypeEntity playTypeEntity, DateTime startTime, DateTime endTime, DecodeMachinePlayReport decodePrintData, bool isPaperOut)
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷ӡ淨ʱα");
                    return;
                }

                MacReportService macReportService = new MacReportService();
                List<KeycodeInfo> keycodeInfoList = macReportService.GetMachinePlayReportKeycodeList(MachineInfo, playTypeEntity, startTime, endTime);
                //մӡջ
                VirtualPrinter.ClearBuffer();

                VirtualKeyboard.Input(keycodeInfoList);
                decodePrintData.InputData = VirtualPrinter.Output();
                if (isPaperOut)
                {
                    //PrinterClient.AddBytes(decodePrintData.InputData.CaptureDataBytes);
                }
                macReportService.DecodeMachinePlayReportReport(MachineInfo, decodePrintData);
                MacCurrentMode = null;
                MacCurrentExpect = null;

                //EnterSaleGui();//۽
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ӡ淨ʱα", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                throw new Exception(ex.Message);
            }
        }

        /// <summary>
        /// 鿴н
        /// </summary>
        /// <param name="ticketEntity"></param>
        public override void ViewPrizeMoney(L_LotTicketEntity ticketEntity)
        {
            try
            {

                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷鿴н");
                    return;
                }
                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                //ҽ
                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_BeforeEncashKeys))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_BeforeEncashKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                //Ʊ
                for (int i = 0; i < ticketEntity.L_TicketCode.Length; i++)
                {
                    keycodeList.Add(new KeycodeInfo(ticketEntity.L_TicketCode.Substring(i, 1), MachineInfo.MachineConfigEntity.C_SendKeyInterval));
                }
                //
                for (int i = 0; i < ticketEntity.L_Password.Length; i++)
                {
                    keycodeList.Add(new KeycodeInfo(ticketEntity.L_TicketCode.Substring(i, 1), MachineInfo.MachineConfigEntity.C_SendKeyInterval));
                }
                //ҽȷϣͣڽ棩
                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_ViewPrizeKeys))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_ViewPrizeKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                VirtualKeyboard.Input(keycodeList);
                MacCurrentMode = null;
                MacCurrentExpect = null;
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "鿴н", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                throw new Exception(ex.Message);
            }
        }
        /// <summary>
        /// ַַ
        /// </summary>
        /// <param name="source"></param>
        /// <param name="chr"></param>
        /// <returns></returns>
        private string InsertChar(string source, string chr)
        {
            int length = source.Length;
            if (length > 1)
            {
                for (int i = length - 1; i > 0; i--)
                {
                    source = source.Insert(i, chr);
                }
            }

            return source;
        }
        /// <summary>
        /// ¼Ʊ
        /// </summary>
        public override void Login()
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷¼");
                    return;
                }
                Log.Info("ʼִе¼Ʊ");

                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                string loginKeys = MachineInfo.MachineConfigEntity.C_LoginKeys;
                if (!string.IsNullOrEmpty(loginKeys))
                {
                    string zxNumber = InsertChar(MachineInfo.M_ZxNumber, ",");
                    string zxPassword = InsertChar(MachineInfo.M_ZxPassword, ",");
                    loginKeys = loginKeys.Replace("zxnumber", zxNumber).Replace("zxpassword", zxPassword);
                    foreach (string key in loginKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                VirtualKeyboard.Input(keycodeList);
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "¼Ʊ", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                //return (int)(WcfCodeEnum.LoginMahineException);
            }
        }

        /// <summary>
        /// رղƱ
        /// </summary>
        public override void Shutdown()
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷ر");
                    return;
                }

                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                string shutdownKeys = MachineInfo.MachineConfigEntity.C_ShutdownKeys;
                if (!string.IsNullOrEmpty(shutdownKeys))
                {
                    foreach (string key in shutdownKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                VirtualKeyboard.Input(keycodeList);
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "رղƱ", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                //return (int)(WcfCodeEnum.ShutdownMahineException);
            }
        }

        /// <summary>
        /// ӡƱ
        /// </summary>
        public override CaptureDataInfo PrintTestTicket(bool isPaperOut)
        {
            CaptureDataInfo captureData = new CaptureDataInfo(new byte[] { });
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷ӡƱ");
                    return captureData;
                }

                VirtualPrinter.ClearBuffer();
                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_PrintTestTicketKeys))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_PrintTestTicketKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                VirtualKeyboard.Input(keycodeList);

                captureData = new CaptureDataInfo(VirtualPrinter.Output().CaptureDataBytes);
                //PrinterClient.AddBytes(VirtualPrinter.Output().CaptureDataBytes);

                MacCurrentMode = null;
                MacCurrentExpect = null;
                IsPrintedTest = true;

            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ӡƱ", MachineInfo.M_Number, ex.Message, ex.StackTrace));
            }
            return captureData;
        }


        /// <summary>
        /// ӡϢ
        /// </summary>
        public override CaptureDataInfo PrintMatch(int lotId)
        {
            CaptureDataInfo captureData = new CaptureDataInfo(new byte[] { });
            try
            {
                VirtualPrinter.ClearBuffer();
                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();

                if (lotId == (int)Lottype.Jz)
                {
                    if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_PrintJzMatchKeys))
                    {
                        foreach (string key in MachineInfo.MachineConfigEntity.C_PrintJzMatchKeys.Split(','))
                        {
                            keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                        }
                    }
                }
                else if (lotId == (int)Lottype.Jl)
                {
                    if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_PrintJlMatchKeys))
                    {
                        foreach (string key in MachineInfo.MachineConfigEntity.C_PrintJlMatchKeys.Split(','))
                        {
                            keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                        }
                    }
                }

                VirtualKeyboard.Input(keycodeList);

                captureData = new CaptureDataInfo(VirtualPrinter.Output().CaptureDataBytes);
                //PrinterClient.AddBytes(VirtualPrinter.Output().CaptureDataBytes);


                if (captureData.CaptureDataBytes.Length > 0)
                {
                    //this.VirtualPrinter.SaveLastFile(captureData.CaptureDataBytes);
                    Log.Info(string.Concat("ӡɹID", lotId));
                }
                else
                {
                    Log.Info(string.Concat("ӡʧܣID", lotId));
                }

                ReturnTopGui();

                IsPrintedTest = true;
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ӡ", MachineInfo.M_Number, ex.Message, ex.StackTrace));
            }
            return captureData;
        }

        /// <summary>
        /// ӡʶϢ
        /// </summary>
        /// <param name="lotId">ʲid</param>
        /// <param name="index">1-ǰڣ2-һڣ3-</param>
        /// <returns></returns>
        public override CaptureDataInfo PrintZcMatch(int lotId, int index)
        {
            return new CaptureDataInfo(new byte[] { });
        }

        /// <summary>
        /// ӡ
        /// </summary>
        public override CaptureDataInfo PrintOpenCodeReport(int lotId)
        {
            CaptureDataInfo captureData = new CaptureDataInfo(new byte[] { });
            try
            {
                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                string keys = "esc,esc,esc,f3,wait500,1,2,wait200,0,5,wait4000,enter";
                foreach (string key in keys.Split(','))
                {
                    keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                }

                //մӡջ
                VirtualPrinter.ClearBuffer();

                VirtualKeyboard.Input(keycodeList);
                captureData = new CaptureDataInfo(VirtualPrinter.Output().CaptureDataBytes);

                ReturnTopGui();
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ӡ", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                throw new Exception(ex.Message);
            }
            return captureData;
        }

        /// <summary>
        /// Ʊϼƽ
        /// </summary>
        /// <returns>Ƿɹ</returns>
        public override void ClearMahineMoney()
        {
            try
            {
                //MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                //if (status != MachineStatusEnum.Stopped)
                //{
                //    Log.Info("ֹͣ״̬޷Ʊϼ");
                //    return;
                //}

                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_ClearAmountKeys))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_ClearAmountKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                VirtualKeyboard.Input(keycodeList);

                ReturnTopGui();

            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "Ʊϼ", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                //return (int)(WcfCodeEnum.ClearMahineMoneyException);
            }
        }

        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="errorType"></param>
        /*public override void ClearError(int errorType)
        {
            try
            {
                string msg = string.Concat("Ʊ[", errorType == (int)MachineErrorType.JcExpectUpdate ? "Ѹ" : "Ѹı", "]");
                Log.Info(msg);
                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                keycodeList.Add(new KeycodeInfo("enter", 30));
                keycodeList.Add(new KeycodeInfo("esc", 1500));
                keycodeList.Add(new KeycodeInfo("enter", 1500));
                if (errorType == (int)MachineErrorType.JlConditionChange && CurrentTicket.LotId == (int)Lottype.Jl)
                {
                    Log.Info("Ʊ[Ѹı]½۽");
                    keycodeList.Add(new KeycodeInfo("esc", 1500));
                    keycodeList.Add(new KeycodeInfo("esc", 1500));
                    //keycodeList.Add(new KeycodeInfo("wait1500", 1500));
                    keycodeList.Add(new KeycodeInfo("0", 1500));
                    keycodeList.Add(new KeycodeInfo("1", 30));
                    keycodeList.Add(new KeycodeInfo("5", 30));
                    keycodeList.Add(new KeycodeInfo("1", 30));
                }
                this.VirtualKeyboard.Input(keycodeList);
                int totaltime = 0;
                foreach (KeycodeInfo keycodeInfo in keycodeList)
                {
                    totaltime += keycodeInfo.SendInterval;
                }
                Wait2(totaltime); 
            }
            catch (Exception exception)
            {
                Log.Error(string.Concat("Ʊ쳣Ϣ",exception));
            }
        }*/
        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="errorType"></param>
        public override void ClearError(int errorType)
        {
            try
            {
                MachineErrorType machineErrorType = (MachineErrorType)errorType;

                string msg = string.Concat("Ʊ[", EnumDescription.GetFieldText(machineErrorType), "]");

                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();

                ////ܻǷ˳ϵͳĶԻҪ
                //keycodeList.Add(new KeycodeInfo("esc", 300));
                //keycodeList.Add(new KeycodeInfo("esc", 300));
                if (machineErrorType == MachineErrorType.JcStopSale)
                {
                    //ܻǷ˳ϵͳĶԻҪ
                    keycodeList.Add(new KeycodeInfo("esc", 300));
                    keycodeList.Add(new KeycodeInfo("esc", 300));

                    keycodeList.Add(new KeycodeInfo("enter", 300));
                }
                else if (machineErrorType == MachineErrorType.JcExpectUpdate)
                {
                    //ܻǷ˳ϵͳĶԻҪ
                    keycodeList.Add(new KeycodeInfo("esc", 300));
                    keycodeList.Add(new KeycodeInfo("esc", 300));

                    keycodeList.Add(new KeycodeInfo("enter", 300));
                    keycodeList.Add(new KeycodeInfo("esc", 1500));
                    keycodeList.Add(new KeycodeInfo("enter", 1500));
                }
                else
                {
                    //keycodeList.Add(new KeycodeInfo("enter", 300));
                    //keycodeList.Add(new KeycodeInfo("esc", 1500));
                    //keycodeList.Add(new KeycodeInfo("enter", 1500));
                    //if (CurrentTicket.LotId == (int)Lottype.Jl)
                    //{
                    msg = "Ʊ[Ѹı]½۽";
                    ////keycodeList.Add(new KeycodeInfo("esc", 2000));
                    ////keycodeList.Add(new KeycodeInfo("esc", 3000));
                    ////keycodeList.Add(new KeycodeInfo("0", 4000));
                    ////keycodeList.Add(new KeycodeInfo("1", 300));
                    ////keycodeList.Add(new KeycodeInfo("5", 300));
                    ////keycodeList.Add(new KeycodeInfo("1", 300));
                    //keycodeList.Add(new KeycodeInfo("5", 300));
                    //keycodeList.Add(new KeycodeInfo("1", 300));
                    //keycodeList.Add(new KeycodeInfo("f3", 3000));
                    //keycodeList.Add(new KeycodeInfo("esc", 300));

                    keycodeList.Add(new KeycodeInfo("enter", 300));
                    keycodeList.Add(new KeycodeInfo("f3", 3000));
                    keycodeList.Add(new KeycodeInfo("esc", 300));
                    keycodeList.Add(new KeycodeInfo("esc", 300));
                    keycodeList.Add(new KeycodeInfo("enter", 300));
                    //}
                    //else
                    //{
                    //    keycodeList.Add(new KeycodeInfo("enter", 300));
                    //    keycodeList.Add(new KeycodeInfo("esc", 1500));
                    //    keycodeList.Add(new KeycodeInfo("enter", 1500));
                    //}
                }
                keycodeList.Add(new KeycodeInfo("wait", 300));
                Log.Info(msg);
                VirtualKeyboard.Input(keycodeList);
                int totaltime = 0;
                foreach (KeycodeInfo keycodeInfo in keycodeList)
                {
                    totaltime += keycodeInfo.SendInterval;
                }
                Wait2(totaltime);
                Log.Info(msg + "");

                ReturnTopGui();
            }
            catch (Exception exception)
            {
                Log.Error(string.Concat("Ʊ쳣Ϣ", exception));
            }
        }

        /// <summary>
        /// ƱѸ¡ʣ
        /// </summary>
        public override void ClearExpectUpdate()
        {
            try
            {
                Log.Info("Ʊ[Ѹ]");
                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                keycodeList.Add(new KeycodeInfo("5", 30));
                keycodeList.Add(new KeycodeInfo("1", 30));
                keycodeList.Add(new KeycodeInfo("enter", 300));
                keycodeList.Add(new KeycodeInfo("esc", 300));
                this.VirtualKeyboard.Input(keycodeList);
            }
            catch (Exception exception)
            {
                Log.Error(string.Concat("Ʊ[Ѹ]쳣Ϣ", exception));
            }
        }

        /// <summary>
        /// ˢ»
        /// </summary>
        /// <returns></returns>
        public override void RefreshMahineMoney()
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷ˢ»");
                    return;
                }
                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_RefreshMoneyKeys))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_RefreshMoneyKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                VirtualKeyboard.Input(keycodeList);

                ReturnTopGui();
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ˢ»", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                //return (int)(WcfCodeEnum.RefreshMahineMoneyException);
            }
        }

        /// <summary>
        /// ˢ¹㲥Ϣ
        /// </summary>
        /// <returns></returns>
        public override void RefreshMahineBroadcast()
        {
            try
            {
                MachineStatusEnum status = (MachineStatusEnum)MachineInfo.M_Status;
                if (status != MachineStatusEnum.Stopped)
                {
                    Log.Info("ֹͣ״̬޷ˢ¹㲥Ϣ");
                    return;
                }
                List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
                if (!string.IsNullOrEmpty(MachineInfo.MachineConfigEntity.C_RefreshBroadcastKeys))
                {
                    foreach (string key in MachineInfo.MachineConfigEntity.C_RefreshBroadcastKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(key, MachineInfo.MachineConfigEntity.C_SendCommandInterval));
                    }
                }
                VirtualKeyboard.Input(keycodeList);
                ReturnTopGui();
            }
            catch (Exception ex)
            {
                Log.Error(string.Format("{0}{1}쳣{2}\r\n{3}", "ˢ¹㲥Ϣ", MachineInfo.M_Number, ex.Message, ex.StackTrace));
                //return (int)(WcfCodeEnum.RefreshMahineBroadcastException);
            }
        }

        /// <summary>
        /// лǰ淨
        /// </summary>
        /// <param name="ticketEntity"></param>
        public override void SetCurrentLotPlayMode(L_LotTicketEntity ticketEntity)
        {
            int totalwaittime = 0;
            int keycount = 0;
            bool ischangceplaytype = false;
            if (MacCurrentMode == null)
            {
                ischangceplaytype = true;
            }
            else
            {
                if (MacCurrentMode.C_MacModeId != ticketEntity.MacModeId)
                {
                    ischangceplaytype = true;
                }
            }

            string oldexpect = MacCurrentExpect;
            int oldlotid = MacCurrentMode == null ? -1 : MacCurrentMode.C_MacLotId;
            M_MachineModeConfigEntity machineModeConfig = MachineInfo.MachineModeConfigs[ticketEntity.MacModeId];
            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            #region л淨
            if (MacCurrentMode == null)
            {
                //лּ淨
                if (!string.IsNullOrEmpty(machineModeConfig.C_MacLotKeys))
                {
                    foreach (string keyname in machineModeConfig.C_MacLotKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_MacLotKeysInterval));
                    }
                }

                if (!string.IsNullOrEmpty(machineModeConfig.C_MacPlayKeys))
                {
                    foreach (string keyname in machineModeConfig.C_MacPlayKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_MacPlayKeysInterval));
                    }
                    keycount += 10;
                }
            }
            else
            {
                if (MacCurrentMode.C_MacLotId != machineModeConfig.C_MacLotId)
                {
                    //лּ淨
                    if (!string.IsNullOrEmpty(machineModeConfig.C_MacLotKeys))
                    {
                        foreach (string keyname in machineModeConfig.C_MacLotKeys.Split(','))
                        {
                            keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_MacLotKeysInterval));
                        }
                        keycount += 10;
                    }


                    if (!string.IsNullOrEmpty(machineModeConfig.C_MacPlayKeys))
                    {
                        foreach (string keyname in machineModeConfig.C_MacPlayKeys.Split(','))
                        {
                            keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_MacPlayKeysInterval));
                        }
                        keycount += 10;
                    }
                    oldexpect = "";

                }
                else
                {
                    if (MacCurrentMode.C_MacPlayId != machineModeConfig.C_MacPlayId)
                    {
                        //л淨
                        if (!string.IsNullOrEmpty(machineModeConfig.C_MacPlayKeys))
                        {
                            foreach (string keyname in machineModeConfig.C_MacPlayKeys.Split(','))
                            {
                                keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_MacPlayKeysInterval));
                            }
                            keycount += 10;
                        }
                        oldexpect = "";
                    }
                }
            }
            #endregion
            if (keycodeList.Count > 0)
            {
                keycount += keycodeList.Count;
                Log.Info("л淨");
                VirtualKeyboard.Input(keycodeList);
                foreach (KeycodeInfo keycodeInfo in keycodeList)
                {
                    totalwaittime += keycodeInfo.SendInterval;
                }
                keycodeList.Clear();
            }


            #region лں
            if (machineModeConfig.C_MacLotId == 601 || machineModeConfig.C_MacLotId == 611 || machineModeConfig.C_MacLotId == 602 || machineModeConfig.C_MacLotId == 603)
            {

                if (oldlotid == machineModeConfig.C_MacLotId)
                {
                    //һͬ
                    if (oldexpect != ticketEntity.L_Expect)
                    {
                        //ںһβͬ

                        if (ticketEntity.L_CurrentExpect == ticketEntity.L_Expect)
                        {
                            //ǰ
                            if (!string.IsNullOrEmpty(machineModeConfig.C_CurrentExpectKeys))
                            {
                                foreach (string keyname in machineModeConfig.C_CurrentExpectKeys.Split(','))
                                {
                                    keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_CurrentExpectKeysInterval));
                                }
                            }
                        }
                        else
                        {
                            //һ
                            if (!string.IsNullOrEmpty(machineModeConfig.C_NextExpectKeys))
                            {
                                foreach (string keyname in machineModeConfig.C_NextExpectKeys.Split(','))
                                {
                                    keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_NextExpectKeysInterval));
                                }
                            }
                        }
                    }
                }
                else
                {
                    //һβͬ ּǵǰ
                    if (ticketEntity.L_CurrentExpect != ticketEntity.L_Expect)
                    {
                        if (!string.IsNullOrEmpty(machineModeConfig.C_NextExpectKeys))
                        {
                            foreach (string keyname in machineModeConfig.C_NextExpectKeys.Split(','))
                            {
                                keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_NextExpectKeysInterval));
                            }
                        }
                    }
                }
            }
            #endregion
            if (keycodeList.Count > 0)
            {
                keycount += keycodeList.Count;
                Log.Info("лں");
                VirtualKeyboard.Input(keycodeList);
                foreach (KeycodeInfo keycodeInfo in keycodeList)
                {
                    totalwaittime += keycodeInfo.SendInterval;
                }
                keycodeList.Clear();
            }

            #region лͶעģʽ
            if (MacCurrentMode == null)
            {
                //Ͷעģʽ
                if (!machineModeConfig.C_IsEveryInit && !string.IsNullOrEmpty(machineModeConfig.C_MacModeKeys))
                {
                    foreach (string keyname in machineModeConfig.C_MacModeKeys.Split(','))
                    {
                        keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_MacModeKeysInterval));
                    }
                }
            }
            else
            {
                if (MacCurrentMode.C_MacModeId != machineModeConfig.C_MacModeId)
                {

                    if (MacCurrentMode.C_MacPlayId == machineModeConfig.C_MacPlayId)
                    {
                        //سʼͶעģʽ
                        if (!string.IsNullOrEmpty(MacCurrentMode.C_ToInitModeKeys))
                        {
                            foreach (string keyname in MacCurrentMode.C_ToInitModeKeys.Split(','))
                            {
                                keycodeList.Add(new KeycodeInfo(keyname, MacCurrentMode.C_ToInitModeKeysInterval));
                            }
                        }
                    }


                    //Ͷעģʽ
                    if (!machineModeConfig.C_IsEveryInit && !string.IsNullOrEmpty(machineModeConfig.C_MacModeKeys))
                    {
                        foreach (string keyname in machineModeConfig.C_MacModeKeys.Split(','))
                        {
                            keycodeList.Add(new KeycodeInfo(keyname, machineModeConfig.C_MacModeKeysInterval));
                        }
                    }
                }
            }
            #endregion
            if (keycodeList.Count > 0)
            {
                keycount += keycodeList.Count;
                Log.Info("лͶעģʽ");
                VirtualKeyboard.Input(keycodeList);
                foreach (KeycodeInfo keycodeInfo in keycodeList)
                {
                    totalwaittime += keycodeInfo.SendInterval;
                }
                keycodeList.Clear();
            }
            /*if (keycount > 0)
            {
                int waittime = MachineInfo.MachineConfigEntity.C_ChangePlayInterval + keycount * 130;
                Log.Info(string.Concat("л淨Ͷעģʽںŵȴ", waittime));
                keycodeList.Add(new KeycodeInfo("wait" + waittime, waittime));
                VirtualKeyboard.Input(keycodeList);
                foreach (KeycodeInfo keycodeInfo in keycodeList)
                {
                    totalwaittime += keycodeInfo.SendInterval;
                }
                keycodeList.Clear();
            }*/

            if (!ischangceplaytype)
            {
                int waittime = 200;
                if (FuShiPlayList.Contains(ticketEntity.L_PlayId))
                {
                    waittime = MachineInfo.MachineConfigEntity.C_ChangePlayInterval;
                }
                keycodeList.Add(new KeycodeInfo("wait" + waittime, waittime));
                VirtualKeyboard.Input(keycodeList);
                foreach (KeycodeInfo keycodeInfo in keycodeList)
                {
                    totalwaittime += keycodeInfo.SendInterval;
                }
                keycodeList.Clear();
                //Wait(waittime);
            }
            if (totalwaittime > 0)
            {
                Wait(totalwaittime);
            }

            //ûǰںżͶעģʽ
            MacCurrentExpect = ticketEntity.L_Expect;
            MacCurrentMode = (M_MachineModeConfigEntity)machineModeConfig.Clone();
        }

        /// <summary>
        /// ض
        /// </summary>
        public override void ReturnTopGui()
        {
            MacCurrentMode = null;
            MacCurrentExpect = null;

            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            keycodeList.Add(new KeycodeInfo("esc", 300));
            keycodeList.Add(new KeycodeInfo("esc", 300));
            keycodeList.Add(new KeycodeInfo("esc", 300));
            Log.Info("Ʊ붥");
            VirtualKeyboard.Input(keycodeList);
        }

        /// <summary>
        /// 棨ʣ
        /// </summary>
        public override void EnterSaleGui()
        {
            ReturnTopGui();

            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();
            keycodeList.Add(new KeycodeInfo("5", 300));
            keycodeList.Add(new KeycodeInfo("1", 30));
            Log.Info("Ʊ뾹");
            VirtualKeyboard.Input(keycodeList);
        }

        /// <summary>
        /// Ʊֵ
        /// </summary>
        public override void Recharge(int money)
        {
            List<KeycodeInfo> keycodeList = new List<KeycodeInfo>();

            ReturnTopGui();
            Wait2(2000);

            keycodeList.Add(new KeycodeInfo("/", 500));  //𵯴
            keycodeList.Add(new KeycodeInfo("f1", 300));  //Ĭ֧
            string moneyStr = money.ToString();
            for (int i = 0; i < moneyStr.Length; i++)
            {
                keycodeList.Add(new KeycodeInfo(moneyStr.Substring(i, 1), 300));  //
            }
            keycodeList.Add(new KeycodeInfo("enter", 300));   //ά
            int totaltime = 0;
            foreach (KeycodeInfo keycodeInfo in keycodeList)
            {
                totaltime += keycodeInfo.SendInterval;
            }
            VirtualKeyboard.Input(keycodeList);
            Wait2(totaltime);
            Log.Info("ѵֵά룬ʼȡֵɹָ");

            //ʼȡֵɹָ
            DateTime startTime = DateTime.Now;
            while (DateTime.Now.Subtract(startTime).TotalSeconds < 60)  //ֹ60뵹ʱ֧ɹп70Ż⵽
            {
                try
                {
                    //ȡָ
                    A10009GetCommand pack = new A10009GetCommand();
                    pack.AgentId = MachineInfo.M_Number;
                    pack.Salt = MachineInfo.M_Salt;
                    A10009GetCommandRet packRet = PackManager.Instance.Send(pack) as A10009GetCommandRet;
                    if (packRet.Code > 0)
                    {
                        Log.Info("ȡָ:" + packRet.Command);
                        if (packRet.Command == "enter_paysuc")    //ֵɹָ
                        {
                            keycodeList.Clear();
                            keycodeList.Add(new KeycodeInfo("enter", 300));
                            VirtualKeyboard.Input(keycodeList);

                            break;
                        }
                    }
                }
                catch (Exception ex)
                {
                    Log.Warn("ȡɹָʧܣ" + ex.ToString());
                }
                finally
                {
                    Wait2(3 * 1000);
                }
            }

            ReturnTopGui();

        }

        #endregion
    }
}
